# ClientsApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**clientsCreateClientPost**](ClientsApi.md#clientsCreateClientPost) | **POST** /Clients/CreateClient | Create a client.    Requires the &#39;ManageClientsAndProjects&#39; permission.
[**clientsGetClientGet**](ClientsApi.md#clientsGetClientGet) | **GET** /Clients/GetClient | Get a particular client.    Requires the &#39;ManageClientsAndProjects&#39; or &#39;ManageJobsAndTask&#39; permissions.
[**clientsGetClientsGet**](ClientsApi.md#clientsGetClientsGet) | **GET** /Clients/GetClients | Get a collection of clients that are under your organisation.    Requires the &#39;ManageClientsAndProjects&#39; or &#39;ManageJobsAndTask&#39; permissions.
[**clientsUpdateClientPut**](ClientsApi.md#clientsUpdateClientPut) | **PUT** /Clients/UpdateClient | Update a client.    Requires the &#39;ManageClientsAndProjects&#39; permission.



## clientsCreateClientPost

> Int32ApiResponse clientsCreateClientPost(insertClientRequest)

Create a client.    Requires the &#39;ManageClientsAndProjects&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ClientsApi;

ClientsApi apiInstance = new ClientsApi();
InsertClientRequest insertClientRequest = new InsertClientRequest(); // InsertClientRequest | An Insert Client Request object containing values for the new Client to create
try {
    Int32ApiResponse result = apiInstance.clientsCreateClientPost(insertClientRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ClientsApi#clientsCreateClientPost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertClientRequest** | [**InsertClientRequest**](InsertClientRequest.md)| An Insert Client Request object containing values for the new Client to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## clientsGetClientGet

> ClientApiResponse clientsGetClientGet(clientId)

Get a particular client.    Requires the &#39;ManageClientsAndProjects&#39; or &#39;ManageJobsAndTask&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ClientsApi;

ClientsApi apiInstance = new ClientsApi();
Integer clientId = null; // Integer | The ID of the Client you want to get
try {
    ClientApiResponse result = apiInstance.clientsGetClientGet(clientId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ClientsApi#clientsGetClientGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **Integer**| The ID of the Client you want to get | [optional] [default to null]

### Return type

[**ClientApiResponse**](ClientApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## clientsGetClientsGet

> ClientListApiResponse clientsGetClientsGet()

Get a collection of clients that are under your organisation.    Requires the &#39;ManageClientsAndProjects&#39; or &#39;ManageJobsAndTask&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ClientsApi;

ClientsApi apiInstance = new ClientsApi();
try {
    ClientListApiResponse result = apiInstance.clientsGetClientsGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ClientsApi#clientsGetClientsGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**ClientListApiResponse**](ClientListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## clientsUpdateClientPut

> BooleanApiResponse clientsUpdateClientPut(saveClientRequest)

Update a client.    Requires the &#39;ManageClientsAndProjects&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ClientsApi;

ClientsApi apiInstance = new ClientsApi();
SaveClientRequest saveClientRequest = new SaveClientRequest(); // SaveClientRequest | A Save Client Request object containing updated fields.  Make sure to specify the Client Id in the request object so that ChronoSheets knows which Client to update
try {
    BooleanApiResponse result = apiInstance.clientsUpdateClientPut(saveClientRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ClientsApi#clientsUpdateClientPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saveClientRequest** | [**SaveClientRequest**](SaveClientRequest.md)| A Save Client Request object containing updated fields.  Make sure to specify the Client Id in the request object so that ChronoSheets knows which Client to update | [optional]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

