# FileAttachmentsApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**fileAttachmentsDeleteTimesheetFileAttachmentDelete**](FileAttachmentsApi.md#fileAttachmentsDeleteTimesheetFileAttachmentDelete) | **DELETE** /FileAttachments/DeleteTimesheetFileAttachment | Delete a particular timesheet file attachment  Requires the &#39;SubmitTimesheets&#39; permission.
[**fileAttachmentsGetFileAttachmentByIdGet**](FileAttachmentsApi.md#fileAttachmentsGetFileAttachmentByIdGet) | **GET** /FileAttachments/GetFileAttachmentById | Get a particular file attachment by ID.  User must own the file attachment for access.
[**fileAttachmentsGetMyFileAttachmentsGet**](FileAttachmentsApi.md#fileAttachmentsGetMyFileAttachmentsGet) | **GET** /FileAttachments/GetMyFileAttachments | Get my file attachments.  Get files you&#39;ve attached to timesheets.



## fileAttachmentsDeleteTimesheetFileAttachmentDelete

> BooleanApiResponse fileAttachmentsDeleteTimesheetFileAttachmentDelete(fileAttachmentId)

Delete a particular timesheet file attachment  Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.FileAttachmentsApi;

FileAttachmentsApi apiInstance = new FileAttachmentsApi();
Integer fileAttachmentId = null; // Integer | The Id of the file attachment to delete
try {
    BooleanApiResponse result = apiInstance.fileAttachmentsDeleteTimesheetFileAttachmentDelete(fileAttachmentId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileAttachmentsApi#fileAttachmentsDeleteTimesheetFileAttachmentDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileAttachmentId** | **Integer**| The Id of the file attachment to delete | [optional] [default to null]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## fileAttachmentsGetFileAttachmentByIdGet

> TimesheetFileAttachmentApiResponse fileAttachmentsGetFileAttachmentByIdGet(fileAttachmentId)

Get a particular file attachment by ID.  User must own the file attachment for access.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.FileAttachmentsApi;

FileAttachmentsApi apiInstance = new FileAttachmentsApi();
Integer fileAttachmentId = null; // Integer | The ID of the file attachment
try {
    TimesheetFileAttachmentApiResponse result = apiInstance.fileAttachmentsGetFileAttachmentByIdGet(fileAttachmentId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileAttachmentsApi#fileAttachmentsGetFileAttachmentByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileAttachmentId** | **Integer**| The ID of the file attachment | [optional] [default to null]

### Return type

[**TimesheetFileAttachmentApiResponse**](TimesheetFileAttachmentApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## fileAttachmentsGetMyFileAttachmentsGet

> TimesheetFileAttachmentListApiResponseForPaginated fileAttachmentsGetMyFileAttachmentsGet(startDate, endDate, skip, take)

Get my file attachments.  Get files you&#39;ve attached to timesheets.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.FileAttachmentsApi;

FileAttachmentsApi apiInstance = new FileAttachmentsApi();
Date startDate = null; // Date | The Start date of the date range.  File attachments after this date will be obtained.
Date endDate = null; // Date | The End date of the date range.  File attachments before this date will be obtained.
Integer skip = 0; // Integer | Skip this many File attachments
Integer take = 10; // Integer | Take this many File attachments
try {
    TimesheetFileAttachmentListApiResponseForPaginated result = apiInstance.fileAttachmentsGetMyFileAttachmentsGet(startDate, endDate, skip, take);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FileAttachmentsApi#fileAttachmentsGetMyFileAttachmentsGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The Start date of the date range.  File attachments after this date will be obtained. | [optional] [default to null]
 **endDate** | **Date**| The End date of the date range.  File attachments before this date will be obtained. | [optional] [default to null]
 **skip** | **Integer**| Skip this many File attachments | [optional] [default to 0]
 **take** | **Integer**| Take this many File attachments | [optional] [default to 10]

### Return type

[**TimesheetFileAttachmentListApiResponseForPaginated**](TimesheetFileAttachmentListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

