# FleetApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**fleetCreateVehiclePost**](FleetApi.md#fleetCreateVehiclePost) | **POST** /Fleet/CreateVehicle | Create a vehicle.    Requires the &#39;ManageFleet&#39; permission.
[**fleetDeleteVehicleDelete**](FleetApi.md#fleetDeleteVehicleDelete) | **DELETE** /Fleet/DeleteVehicle | Delete a vehicle from the fleet.  Requires the &#39;ManageFleet&#39; permission.
[**fleetGetVehicleByIdGet**](FleetApi.md#fleetGetVehicleByIdGet) | **GET** /Fleet/GetVehicleById | Get a particular vehicle.  Does not require any special permission.
[**fleetGetVehiclesGet**](FleetApi.md#fleetGetVehiclesGet) | **GET** /Fleet/GetVehicles | Get a collection of vehicles that are under your organisation.    Does not require any special permission.
[**fleetUpdateVehiclePut**](FleetApi.md#fleetUpdateVehiclePut) | **PUT** /Fleet/UpdateVehicle | Update a vehicle.    Requires the &#39;ManageFleet&#39; permission.



## fleetCreateVehiclePost

> Int32ApiResponse fleetCreateVehiclePost(insertVehicleRequest)

Create a vehicle.    Requires the &#39;ManageFleet&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.FleetApi;

FleetApi apiInstance = new FleetApi();
InsertVehicleRequest insertVehicleRequest = new InsertVehicleRequest(); // InsertVehicleRequest | An Insert Vehicle Request object containing values for the new Vehicle to create
try {
    Int32ApiResponse result = apiInstance.fleetCreateVehiclePost(insertVehicleRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FleetApi#fleetCreateVehiclePost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertVehicleRequest** | [**InsertVehicleRequest**](InsertVehicleRequest.md)| An Insert Vehicle Request object containing values for the new Vehicle to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## fleetDeleteVehicleDelete

> BooleanApiResponse fleetDeleteVehicleDelete(vehicleId)

Delete a vehicle from the fleet.  Requires the &#39;ManageFleet&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.FleetApi;

FleetApi apiInstance = new FleetApi();
Integer vehicleId = null; // Integer | The unique ID of the vehicle you wish to delete
try {
    BooleanApiResponse result = apiInstance.fleetDeleteVehicleDelete(vehicleId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FleetApi#fleetDeleteVehicleDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **vehicleId** | **Integer**| The unique ID of the vehicle you wish to delete | [optional] [default to null]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## fleetGetVehicleByIdGet

> FleetVehicleApiResponse fleetGetVehicleByIdGet(vehicleId)

Get a particular vehicle.  Does not require any special permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.FleetApi;

FleetApi apiInstance = new FleetApi();
Integer vehicleId = null; // Integer | The ID of the Vehicle you want to get
try {
    FleetVehicleApiResponse result = apiInstance.fleetGetVehicleByIdGet(vehicleId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FleetApi#fleetGetVehicleByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **vehicleId** | **Integer**| The ID of the Vehicle you want to get | [optional] [default to null]

### Return type

[**FleetVehicleApiResponse**](FleetVehicleApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## fleetGetVehiclesGet

> FleetVehicleListApiResponse fleetGetVehiclesGet(includeDeleted)

Get a collection of vehicles that are under your organisation.    Does not require any special permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.FleetApi;

FleetApi apiInstance = new FleetApi();
Boolean includeDeleted = false; // Boolean | Whether or not to include deleted vehicles
try {
    FleetVehicleListApiResponse result = apiInstance.fleetGetVehiclesGet(includeDeleted);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FleetApi#fleetGetVehiclesGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **includeDeleted** | **Boolean**| Whether or not to include deleted vehicles | [optional] [default to false]

### Return type

[**FleetVehicleListApiResponse**](FleetVehicleListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## fleetUpdateVehiclePut

> BooleanApiResponse fleetUpdateVehiclePut(saveVehicleRequest)

Update a vehicle.    Requires the &#39;ManageFleet&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.FleetApi;

FleetApi apiInstance = new FleetApi();
SaveVehicleRequest saveVehicleRequest = new SaveVehicleRequest(); // SaveVehicleRequest | A Save Vehicle Request object containing updated fields.  Make sure to specify the Vehicle Id in the request object so that ChronoSheets knows which Vehicle to update
try {
    BooleanApiResponse result = apiInstance.fleetUpdateVehiclePut(saveVehicleRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FleetApi#fleetUpdateVehiclePut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saveVehicleRequest** | [**SaveVehicleRequest**](SaveVehicleRequest.md)| A Save Vehicle Request object containing updated fields.  Make sure to specify the Vehicle Id in the request object so that ChronoSheets knows which Vehicle to update | [optional]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

