# GeoFencingApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**geoFencingCreateGeofencePost**](GeoFencingApi.md#geoFencingCreateGeofencePost) | **POST** /GeoFencing/CreateGeofence | Create a geofencing with rules to be used for clock on/off automation.  Requires the &#39;ManageGeofencing&#39; permission.
[**geoFencingDeleteGeofenceDelete**](GeoFencingApi.md#geoFencingDeleteGeofenceDelete) | **DELETE** /GeoFencing/DeleteGeofence | Deletes a geofence.  Requires the &#39;ManageGeofencing&#39; permission.
[**geoFencingGetGeofenceByIdGet**](GeoFencingApi.md#geoFencingGetGeofenceByIdGet) | **GET** /GeoFencing/GetGeofenceById | Get a geofence by ID  Requires the &#39;SubmitTimesheets&#39; permission.
[**geoFencingGetGeofencesBasicInfoGet**](GeoFencingApi.md#geoFencingGetGeofencesBasicInfoGet) | **GET** /GeoFencing/GetGeofencesBasicInfo | Gets a list of all geofences in your organisation, including just the name and ID.
[**geoFencingGetGeofencesGet**](GeoFencingApi.md#geoFencingGetGeofencesGet) | **GET** /GeoFencing/GetGeofences | Get geofences belonging to your organisation  Requires the &#39;SubmitTimesheets&#39; permission.
[**geoFencingUpdateGeofencePut**](GeoFencingApi.md#geoFencingUpdateGeofencePut) | **PUT** /GeoFencing/UpdateGeofence | Updates a geofencing with rules to be used for clock on/off automation.  Requires the &#39;ManageGeofencing&#39; permission.



## geoFencingCreateGeofencePost

> Int32ApiResponse geoFencingCreateGeofencePost(createGeoFenceRequest)

Create a geofencing with rules to be used for clock on/off automation.  Requires the &#39;ManageGeofencing&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.GeoFencingApi;

GeoFencingApi apiInstance = new GeoFencingApi();
CreateGeoFenceRequest createGeoFenceRequest = new CreateGeoFenceRequest(); // CreateGeoFenceRequest | 
try {
    Int32ApiResponse result = apiInstance.geoFencingCreateGeofencePost(createGeoFenceRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling GeoFencingApi#geoFencingCreateGeofencePost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **createGeoFenceRequest** | [**CreateGeoFenceRequest**](CreateGeoFenceRequest.md)|  | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## geoFencingDeleteGeofenceDelete

> GeofenceApiResponse geoFencingDeleteGeofenceDelete(geofenceId)

Deletes a geofence.  Requires the &#39;ManageGeofencing&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.GeoFencingApi;

GeoFencingApi apiInstance = new GeoFencingApi();
Integer geofenceId = null; // Integer | Specify the geofence you want to delete with the geofence ID.
try {
    GeofenceApiResponse result = apiInstance.geoFencingDeleteGeofenceDelete(geofenceId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling GeoFencingApi#geoFencingDeleteGeofenceDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **geofenceId** | **Integer**| Specify the geofence you want to delete with the geofence ID. | [optional] [default to null]

### Return type

[**GeofenceApiResponse**](GeofenceApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## geoFencingGetGeofenceByIdGet

> GeofenceApiResponse geoFencingGetGeofenceByIdGet(geofenceId)

Get a geofence by ID  Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.GeoFencingApi;

GeoFencingApi apiInstance = new GeoFencingApi();
Integer geofenceId = null; // Integer | The ID of the geofence you want to obtain
try {
    GeofenceApiResponse result = apiInstance.geoFencingGetGeofenceByIdGet(geofenceId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling GeoFencingApi#geoFencingGetGeofenceByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **geofenceId** | **Integer**| The ID of the geofence you want to obtain | [optional] [default to null]

### Return type

[**GeofenceApiResponse**](GeofenceApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## geoFencingGetGeofencesBasicInfoGet

> BasicGeofenceListApiResponseForPaginated geoFencingGetGeofencesBasicInfoGet()

Gets a list of all geofences in your organisation, including just the name and ID.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.GeoFencingApi;

GeoFencingApi apiInstance = new GeoFencingApi();
try {
    BasicGeofenceListApiResponseForPaginated result = apiInstance.geoFencingGetGeofencesBasicInfoGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling GeoFencingApi#geoFencingGetGeofencesBasicInfoGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**BasicGeofenceListApiResponseForPaginated**](BasicGeofenceListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## geoFencingGetGeofencesGet

> ExtendedGeofenceListApiResponseForPaginated geoFencingGetGeofencesGet(skip, take)

Get geofences belonging to your organisation  Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.GeoFencingApi;

GeoFencingApi apiInstance = new GeoFencingApi();
Integer skip = 0; // Integer | Number of records to skip
Integer take = 20; // Integer | Number of records to take
try {
    ExtendedGeofenceListApiResponseForPaginated result = apiInstance.geoFencingGetGeofencesGet(skip, take);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling GeoFencingApi#geoFencingGetGeofencesGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **skip** | **Integer**| Number of records to skip | [optional] [default to 0]
 **take** | **Integer**| Number of records to take | [optional] [default to 20]

### Return type

[**ExtendedGeofenceListApiResponseForPaginated**](ExtendedGeofenceListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## geoFencingUpdateGeofencePut

> Int32ApiResponse geoFencingUpdateGeofencePut(updateGeoFenceRequest)

Updates a geofencing with rules to be used for clock on/off automation.  Requires the &#39;ManageGeofencing&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.GeoFencingApi;

GeoFencingApi apiInstance = new GeoFencingApi();
UpdateGeoFenceRequest updateGeoFenceRequest = new UpdateGeoFenceRequest(); // UpdateGeoFenceRequest | 
try {
    Int32ApiResponse result = apiInstance.geoFencingUpdateGeofencePut(updateGeoFenceRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling GeoFencingApi#geoFencingUpdateGeofencePut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateGeoFenceRequest** | [**UpdateGeoFenceRequest**](UpdateGeoFenceRequest.md)|  | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

