# JobCodesApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**jobCodesCreateJobCodePost**](JobCodesApi.md#jobCodesCreateJobCodePost) | **POST** /JobCodes/CreateJobCode | Create a job code.    Requires the &#39;ManageJobsAndTask&#39; permission.
[**jobCodesDeleteJobCodeDelete**](JobCodesApi.md#jobCodesDeleteJobCodeDelete) | **DELETE** /JobCodes/DeleteJobCode | Delete a job code.    Requires the &#39;ManageJobsAndTask&#39; permission.
[**jobCodesGetJobCodeByIdGet**](JobCodesApi.md#jobCodesGetJobCodeByIdGet) | **GET** /JobCodes/GetJobCodeById | Get a particular job code by job code id.    Requires &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTasks&#39; permissions.
[**jobCodesGetJobCodesGet**](JobCodesApi.md#jobCodesGetJobCodesGet) | **GET** /JobCodes/GetJobCodes | Get job codes for your organisation.    Requires &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTasks&#39; permissions.
[**jobCodesUpdateJobCodePut**](JobCodesApi.md#jobCodesUpdateJobCodePut) | **PUT** /JobCodes/UpdateJobCode | Update a job code.    Requires the &#39;ManageJobsAndTask&#39; permission.



## jobCodesCreateJobCodePost

> Int32ApiResponse jobCodesCreateJobCodePost(insertJobCodeRequest)

Create a job code.    Requires the &#39;ManageJobsAndTask&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.JobCodesApi;

JobCodesApi apiInstance = new JobCodesApi();
InsertJobCodeRequest insertJobCodeRequest = new InsertJobCodeRequest(); // InsertJobCodeRequest | An Insert JobCode Request object containing values for the new JobCode to create
try {
    Int32ApiResponse result = apiInstance.jobCodesCreateJobCodePost(insertJobCodeRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobCodesApi#jobCodesCreateJobCodePost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertJobCodeRequest** | [**InsertJobCodeRequest**](InsertJobCodeRequest.md)| An Insert JobCode Request object containing values for the new JobCode to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## jobCodesDeleteJobCodeDelete

> BooleanApiResponse jobCodesDeleteJobCodeDelete(jobCodeId)

Delete a job code.    Requires the &#39;ManageJobsAndTask&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.JobCodesApi;

JobCodesApi apiInstance = new JobCodesApi();
Integer jobCodeId = null; // Integer | The ID of the job code you want to delete
try {
    BooleanApiResponse result = apiInstance.jobCodesDeleteJobCodeDelete(jobCodeId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobCodesApi#jobCodesDeleteJobCodeDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **jobCodeId** | **Integer**| The ID of the job code you want to delete | [optional] [default to null]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## jobCodesGetJobCodeByIdGet

> JobCodeApiResponse jobCodesGetJobCodeByIdGet(jobCodeId)

Get a particular job code by job code id.    Requires &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTasks&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.JobCodesApi;

JobCodesApi apiInstance = new JobCodesApi();
Integer jobCodeId = null; // Integer | The ID of the JobCode you want to get
try {
    JobCodeApiResponse result = apiInstance.jobCodesGetJobCodeByIdGet(jobCodeId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobCodesApi#jobCodesGetJobCodeByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **jobCodeId** | **Integer**| The ID of the JobCode you want to get | [optional] [default to null]

### Return type

[**JobCodeApiResponse**](JobCodeApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## jobCodesGetJobCodesGet

> JobCodeListApiResponse jobCodesGetJobCodesGet()

Get job codes for your organisation.    Requires &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTasks&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.JobCodesApi;

JobCodesApi apiInstance = new JobCodesApi();
try {
    JobCodeListApiResponse result = apiInstance.jobCodesGetJobCodesGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobCodesApi#jobCodesGetJobCodesGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**JobCodeListApiResponse**](JobCodeListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## jobCodesUpdateJobCodePut

> BooleanApiResponse jobCodesUpdateJobCodePut(updateJobCodeRequest)

Update a job code.    Requires the &#39;ManageJobsAndTask&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.JobCodesApi;

JobCodesApi apiInstance = new JobCodesApi();
UpdateJobCodeRequest updateJobCodeRequest = new UpdateJobCodeRequest(); // UpdateJobCodeRequest | A Update JobCode Request object containing updated fields.  Make sure to specify the JobCode Id in the request object so that ChronoSheets knows which JobCode to update
try {
    BooleanApiResponse result = apiInstance.jobCodesUpdateJobCodePut(updateJobCodeRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling JobCodesApi#jobCodesUpdateJobCodePut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateJobCodeRequest** | [**UpdateJobCodeRequest**](UpdateJobCodeRequest.md)| A Update JobCode Request object containing updated fields.  Make sure to specify the JobCode Id in the request object so that ChronoSheets knows which JobCode to update | [optional]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

