# NFCCodesApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**nFCCodesCreateNFCCodePost**](NFCCodesApi.md#nFCCodesCreateNFCCodePost) | **POST** /NFCCodes/CreateNFCCode | Create a NFC codes with rules to be used for clock on/off automation.  Requires the &#39;ManageNFCCodes&#39; permission.
[**nFCCodesDeleteNFCCodeDelete**](NFCCodesApi.md#nFCCodesDeleteNFCCodeDelete) | **DELETE** /NFCCodes/DeleteNFCCode | Deletes a NFC code.  Requires the &#39;ManageNFCCodes&#39; permission.
[**nFCCodesGetNFCCodeByIdGet**](NFCCodesApi.md#nFCCodesGetNFCCodeByIdGet) | **GET** /NFCCodes/GetNFCCodeById | Get a NFC code by ID  Requires the &#39;SubmitTimesheets&#39; permission.
[**nFCCodesGetNFCCodesBasicInfoGet**](NFCCodesApi.md#nFCCodesGetNFCCodesBasicInfoGet) | **GET** /NFCCodes/GetNFCCodesBasicInfo | Gets a list of all NFC codes in your organisation, including just the name and ID.
[**nFCCodesGetNFCCodesGet**](NFCCodesApi.md#nFCCodesGetNFCCodesGet) | **GET** /NFCCodes/GetNFCCodes | Get NFC codes belonging to your organisation  Requires the &#39;SubmitTimesheets&#39; permission.
[**nFCCodesUpdateNFCCodePut**](NFCCodesApi.md#nFCCodesUpdateNFCCodePut) | **PUT** /NFCCodes/UpdateNFCCode | Updates a NFC code with rules to be used for clock on/off automation.  Requires the &#39;ManageNFCCodes&#39; permission.



## nFCCodesCreateNFCCodePost

> Int32ApiResponse nFCCodesCreateNFCCodePost(createNFCCodeRequest)

Create a NFC codes with rules to be used for clock on/off automation.  Requires the &#39;ManageNFCCodes&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.NFCCodesApi;

NFCCodesApi apiInstance = new NFCCodesApi();
CreateNFCCodeRequest createNFCCodeRequest = new CreateNFCCodeRequest(); // CreateNFCCodeRequest | 
try {
    Int32ApiResponse result = apiInstance.nFCCodesCreateNFCCodePost(createNFCCodeRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling NFCCodesApi#nFCCodesCreateNFCCodePost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **createNFCCodeRequest** | [**CreateNFCCodeRequest**](CreateNFCCodeRequest.md)|  | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## nFCCodesDeleteNFCCodeDelete

> NFCCodeApiResponse nFCCodesDeleteNFCCodeDelete(nFCCodeId)

Deletes a NFC code.  Requires the &#39;ManageNFCCodes&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.NFCCodesApi;

NFCCodesApi apiInstance = new NFCCodesApi();
Integer nFCCodeId = null; // Integer | Specify the NFC code you want to delete with the NFC code ID.
try {
    NFCCodeApiResponse result = apiInstance.nFCCodesDeleteNFCCodeDelete(nFCCodeId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling NFCCodesApi#nFCCodesDeleteNFCCodeDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **nFCCodeId** | **Integer**| Specify the NFC code you want to delete with the NFC code ID. | [optional] [default to null]

### Return type

[**NFCCodeApiResponse**](NFCCodeApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## nFCCodesGetNFCCodeByIdGet

> NFCCodeApiResponse nFCCodesGetNFCCodeByIdGet(nFCCodeId)

Get a NFC code by ID  Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.NFCCodesApi;

NFCCodesApi apiInstance = new NFCCodesApi();
Integer nFCCodeId = null; // Integer | The ID of the NFC code you want to obtain
try {
    NFCCodeApiResponse result = apiInstance.nFCCodesGetNFCCodeByIdGet(nFCCodeId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling NFCCodesApi#nFCCodesGetNFCCodeByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **nFCCodeId** | **Integer**| The ID of the NFC code you want to obtain | [optional] [default to null]

### Return type

[**NFCCodeApiResponse**](NFCCodeApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## nFCCodesGetNFCCodesBasicInfoGet

> BasicNFCCodeListApiResponseForPaginated nFCCodesGetNFCCodesBasicInfoGet()

Gets a list of all NFC codes in your organisation, including just the name and ID.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.NFCCodesApi;

NFCCodesApi apiInstance = new NFCCodesApi();
try {
    BasicNFCCodeListApiResponseForPaginated result = apiInstance.nFCCodesGetNFCCodesBasicInfoGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling NFCCodesApi#nFCCodesGetNFCCodesBasicInfoGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**BasicNFCCodeListApiResponseForPaginated**](BasicNFCCodeListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## nFCCodesGetNFCCodesGet

> ExtendedNFCCodeListApiResponseForPaginated nFCCodesGetNFCCodesGet(skip, take)

Get NFC codes belonging to your organisation  Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.NFCCodesApi;

NFCCodesApi apiInstance = new NFCCodesApi();
Integer skip = 0; // Integer | Number of records to skip
Integer take = 20; // Integer | Number of records to take
try {
    ExtendedNFCCodeListApiResponseForPaginated result = apiInstance.nFCCodesGetNFCCodesGet(skip, take);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling NFCCodesApi#nFCCodesGetNFCCodesGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **skip** | **Integer**| Number of records to skip | [optional] [default to 0]
 **take** | **Integer**| Number of records to take | [optional] [default to 20]

### Return type

[**ExtendedNFCCodeListApiResponseForPaginated**](ExtendedNFCCodeListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## nFCCodesUpdateNFCCodePut

> Int32ApiResponse nFCCodesUpdateNFCCodePut(updateNFCCodeRequest)

Updates a NFC code with rules to be used for clock on/off automation.  Requires the &#39;ManageNFCCodes&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.NFCCodesApi;

NFCCodesApi apiInstance = new NFCCodesApi();
UpdateNFCCodeRequest updateNFCCodeRequest = new UpdateNFCCodeRequest(); // UpdateNFCCodeRequest | 
try {
    Int32ApiResponse result = apiInstance.nFCCodesUpdateNFCCodePut(updateNFCCodeRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling NFCCodesApi#nFCCodesUpdateNFCCodePut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateNFCCodeRequest** | [**UpdateNFCCodeRequest**](UpdateNFCCodeRequest.md)|  | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

