# OrganisationApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**organisationGetEditTimesheetsOutsideTodayGet**](OrganisationApi.md#organisationGetEditTimesheetsOutsideTodayGet) | **GET** /Organisation/GetEditTimesheetsOutsideToday | Gets the setting for your organisation for editing timesheets outside of current work day.    Requires &#39;SubmitTimesheets&#39; permission.
[**organisationGetOrganisationGet**](OrganisationApi.md#organisationGetOrganisationGet) | **GET** /Organisation/GetOrganisation | Get your organisation.    Requires &#39;OrganisationAdmin&#39; permission.
[**organisationUpdateOrganisationPut**](OrganisationApi.md#organisationUpdateOrganisationPut) | **PUT** /Organisation/UpdateOrganisation | Update an organisation.    Requires &#39;OrganisationAdmin&#39; permission.



## organisationGetEditTimesheetsOutsideTodayGet

> BooleanApiResponse organisationGetEditTimesheetsOutsideTodayGet()

Gets the setting for your organisation for editing timesheets outside of current work day.    Requires &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationApi;

OrganisationApi apiInstance = new OrganisationApi();
try {
    BooleanApiResponse result = apiInstance.organisationGetEditTimesheetsOutsideTodayGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationApi#organisationGetEditTimesheetsOutsideTodayGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## organisationGetOrganisationGet

> OrganisationApiResponse organisationGetOrganisationGet()

Get your organisation.    Requires &#39;OrganisationAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationApi;

OrganisationApi apiInstance = new OrganisationApi();
try {
    OrganisationApiResponse result = apiInstance.organisationGetOrganisationGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationApi#organisationGetOrganisationGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**OrganisationApiResponse**](OrganisationApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## organisationUpdateOrganisationPut

> UpdateOrganisationResponseApiResponse organisationUpdateOrganisationPut(updateOrganisationRequest)

Update an organisation.    Requires &#39;OrganisationAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationApi;

OrganisationApi apiInstance = new OrganisationApi();
UpdateOrganisationRequest updateOrganisationRequest = new UpdateOrganisationRequest(); // UpdateOrganisationRequest | An Update Organsation Request object containing updated fields.  Make sure to specify the Organsation Id in the request object so that ChronoSheets knows which Organsation to update
try {
    UpdateOrganisationResponseApiResponse result = apiInstance.organisationUpdateOrganisationPut(updateOrganisationRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationApi#organisationUpdateOrganisationPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateOrganisationRequest** | [**UpdateOrganisationRequest**](UpdateOrganisationRequest.md)| An Update Organsation Request object containing updated fields.  Make sure to specify the Organsation Id in the request object so that ChronoSheets knows which Organsation to update | [optional]

### Return type

[**UpdateOrganisationResponseApiResponse**](UpdateOrganisationResponseApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

