# OrganisationGroupUsersApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**organisationGroupUsersGetOrganisationGroupUsersGet**](OrganisationGroupUsersApi.md#organisationGroupUsersGetOrganisationGroupUsersGet) | **GET** /OrganisationGroupUsers/GetOrganisationGroupUsers | Get a collection of organisation group users that belong to an organisation group.    Requires the &#39;ManageOrganisationGroups&#39; or &#39;ManageOrganisationUsers&#39; permissions.
[**organisationGroupUsersUpdateOrganisationGroupUsersPut**](OrganisationGroupUsersApi.md#organisationGroupUsersUpdateOrganisationGroupUsersPut) | **PUT** /OrganisationGroupUsers/UpdateOrganisationGroupUsers | Set the users who belong to an organisation group.    Requires the &#39;ManageOrganisationGroups&#39; permissions.



## organisationGroupUsersGetOrganisationGroupUsersGet

> UserForManagementListApiResponse organisationGroupUsersGetOrganisationGroupUsersGet(orgGroupId)

Get a collection of organisation group users that belong to an organisation group.    Requires the &#39;ManageOrganisationGroups&#39; or &#39;ManageOrganisationUsers&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupUsersApi;

OrganisationGroupUsersApi apiInstance = new OrganisationGroupUsersApi();
Integer orgGroupId = null; // Integer | An OrganisationGroup Id
try {
    UserForManagementListApiResponse result = apiInstance.organisationGroupUsersGetOrganisationGroupUsersGet(orgGroupId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupUsersApi#organisationGroupUsersGetOrganisationGroupUsersGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **orgGroupId** | **Integer**| An OrganisationGroup Id | [optional] [default to null]

### Return type

[**UserForManagementListApiResponse**](UserForManagementListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## organisationGroupUsersUpdateOrganisationGroupUsersPut

> BooleanApiResponse organisationGroupUsersUpdateOrganisationGroupUsersPut(setOrganisationGroupUsersRequest)

Set the users who belong to an organisation group.    Requires the &#39;ManageOrganisationGroups&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupUsersApi;

OrganisationGroupUsersApi apiInstance = new OrganisationGroupUsersApi();
SetOrganisationGroupUsersRequest setOrganisationGroupUsersRequest = new SetOrganisationGroupUsersRequest(); // SetOrganisationGroupUsersRequest | A request object specifying which users belong to an organisation group.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update. CsvUserIds is a comma separated list of User Ids, e.g. 1,2,3,4
try {
    BooleanApiResponse result = apiInstance.organisationGroupUsersUpdateOrganisationGroupUsersPut(setOrganisationGroupUsersRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupUsersApi#organisationGroupUsersUpdateOrganisationGroupUsersPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **setOrganisationGroupUsersRequest** | [**SetOrganisationGroupUsersRequest**](SetOrganisationGroupUsersRequest.md)| A request object specifying which users belong to an organisation group.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update. CsvUserIds is a comma separated list of User Ids, e.g. 1,2,3,4 | [optional]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

