# OrganisationGroupsApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**organisationGroupsCreateOrganisationGroupPost**](OrganisationGroupsApi.md#organisationGroupsCreateOrganisationGroupPost) | **POST** /OrganisationGroups/CreateOrganisationGroup | Create an organisation group.    Requires the &#39;ManageOrganisationGroups&#39; permissions.
[**organisationGroupsDeleteOrganisationGroupDelete**](OrganisationGroupsApi.md#organisationGroupsDeleteOrganisationGroupDelete) | **DELETE** /OrganisationGroups/DeleteOrganisationGroup | 
[**organisationGroupsGetOrganisationGroupGet**](OrganisationGroupsApi.md#organisationGroupsGetOrganisationGroupGet) | **GET** /OrganisationGroups/GetOrganisationGroup | Get a particular organisation group.    Requires the &#39;ManageOrganisationGroups&#39;, &#39;ManageJobsAndTask&#39;, &#39;ManageClientsAndProjects&#39; or &#39;ManageOrganisationUsers&#39; permissions.
[**organisationGroupsGetOrganisationGroupsForJobGet**](OrganisationGroupsApi.md#organisationGroupsGetOrganisationGroupsForJobGet) | **GET** /OrganisationGroups/GetOrganisationGroupsForJob | Get org groups for a particular job.    Requires the &#39;ManageOrganisationGroups&#39;, &#39;ManageJobsAndTask&#39;, &#39;ManageClientsAndProjects&#39; or &#39;ManageOrganisationUsers&#39; permissions.
[**organisationGroupsGetOrganisationGroupsForVehicleGet**](OrganisationGroupsApi.md#organisationGroupsGetOrganisationGroupsForVehicleGet) | **GET** /OrganisationGroups/GetOrganisationGroupsForVehicle | Get org groups for a particular vehicle.    Requires the &#39;ManageOrganisationGroups&#39;, &#39;ManageFleet&#39; or &#39;ManageOrganisationUsers&#39; permissions.
[**organisationGroupsGetOrganisationGroupsGet**](OrganisationGroupsApi.md#organisationGroupsGetOrganisationGroupsGet) | **GET** /OrganisationGroups/GetOrganisationGroups | Get a collection of organisation groups that are under your organisation.    Requires the &#39;ManageOrganisationGroups&#39;, &#39;ManageJobsAndTask&#39;, &#39;ManageClientsAndProjects&#39; or &#39;ManageOrganisationUsers&#39; permissions.
[**organisationGroupsUpdateOrganisationGroupPut**](OrganisationGroupsApi.md#organisationGroupsUpdateOrganisationGroupPut) | **PUT** /OrganisationGroups/UpdateOrganisationGroup | Update an organisation group.    Requires the &#39;ManageOrganisationGroups&#39; permissions.



## organisationGroupsCreateOrganisationGroupPost

> Int32ApiResponse organisationGroupsCreateOrganisationGroupPost(insertOrganisationGroupRequest)

Create an organisation group.    Requires the &#39;ManageOrganisationGroups&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupsApi;

OrganisationGroupsApi apiInstance = new OrganisationGroupsApi();
InsertOrganisationGroupRequest insertOrganisationGroupRequest = new InsertOrganisationGroupRequest(); // InsertOrganisationGroupRequest | An Insert OrganisationGroup Request object containing values for the new OrganisationGroup to create
try {
    Int32ApiResponse result = apiInstance.organisationGroupsCreateOrganisationGroupPost(insertOrganisationGroupRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupsApi#organisationGroupsCreateOrganisationGroupPost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertOrganisationGroupRequest** | [**InsertOrganisationGroupRequest**](InsertOrganisationGroupRequest.md)| An Insert OrganisationGroup Request object containing values for the new OrganisationGroup to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## organisationGroupsDeleteOrganisationGroupDelete

> BooleanApiResponse organisationGroupsDeleteOrganisationGroupDelete(organisationGroupId)



### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupsApi;

OrganisationGroupsApi apiInstance = new OrganisationGroupsApi();
Integer organisationGroupId = null; // Integer | 
try {
    BooleanApiResponse result = apiInstance.organisationGroupsDeleteOrganisationGroupDelete(organisationGroupId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupsApi#organisationGroupsDeleteOrganisationGroupDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **organisationGroupId** | **Integer**|  | [optional] [default to null]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## organisationGroupsGetOrganisationGroupGet

> OrganisationGroupApiResponse organisationGroupsGetOrganisationGroupGet(organisationGroupId)

Get a particular organisation group.    Requires the &#39;ManageOrganisationGroups&#39;, &#39;ManageJobsAndTask&#39;, &#39;ManageClientsAndProjects&#39; or &#39;ManageOrganisationUsers&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupsApi;

OrganisationGroupsApi apiInstance = new OrganisationGroupsApi();
Integer organisationGroupId = null; // Integer | The ID of the OrganisationGroup you want to get
try {
    OrganisationGroupApiResponse result = apiInstance.organisationGroupsGetOrganisationGroupGet(organisationGroupId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupsApi#organisationGroupsGetOrganisationGroupGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **organisationGroupId** | **Integer**| The ID of the OrganisationGroup you want to get | [optional] [default to null]

### Return type

[**OrganisationGroupApiResponse**](OrganisationGroupApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## organisationGroupsGetOrganisationGroupsForJobGet

> OrganisationGroupListApiResponse organisationGroupsGetOrganisationGroupsForJobGet(jobId)

Get org groups for a particular job.    Requires the &#39;ManageOrganisationGroups&#39;, &#39;ManageJobsAndTask&#39;, &#39;ManageClientsAndProjects&#39; or &#39;ManageOrganisationUsers&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupsApi;

OrganisationGroupsApi apiInstance = new OrganisationGroupsApi();
Integer jobId = null; // Integer | The ID of the job
try {
    OrganisationGroupListApiResponse result = apiInstance.organisationGroupsGetOrganisationGroupsForJobGet(jobId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupsApi#organisationGroupsGetOrganisationGroupsForJobGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **jobId** | **Integer**| The ID of the job | [optional] [default to null]

### Return type

[**OrganisationGroupListApiResponse**](OrganisationGroupListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## organisationGroupsGetOrganisationGroupsForVehicleGet

> OrganisationGroupListApiResponse organisationGroupsGetOrganisationGroupsForVehicleGet(vehicleId)

Get org groups for a particular vehicle.    Requires the &#39;ManageOrganisationGroups&#39;, &#39;ManageFleet&#39; or &#39;ManageOrganisationUsers&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupsApi;

OrganisationGroupsApi apiInstance = new OrganisationGroupsApi();
Integer vehicleId = null; // Integer | The ID of the vehicle
try {
    OrganisationGroupListApiResponse result = apiInstance.organisationGroupsGetOrganisationGroupsForVehicleGet(vehicleId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupsApi#organisationGroupsGetOrganisationGroupsForVehicleGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **vehicleId** | **Integer**| The ID of the vehicle | [optional] [default to null]

### Return type

[**OrganisationGroupListApiResponse**](OrganisationGroupListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## organisationGroupsGetOrganisationGroupsGet

> OrganisationGroupListApiResponse organisationGroupsGetOrganisationGroupsGet()

Get a collection of organisation groups that are under your organisation.    Requires the &#39;ManageOrganisationGroups&#39;, &#39;ManageJobsAndTask&#39;, &#39;ManageClientsAndProjects&#39; or &#39;ManageOrganisationUsers&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupsApi;

OrganisationGroupsApi apiInstance = new OrganisationGroupsApi();
try {
    OrganisationGroupListApiResponse result = apiInstance.organisationGroupsGetOrganisationGroupsGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupsApi#organisationGroupsGetOrganisationGroupsGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**OrganisationGroupListApiResponse**](OrganisationGroupListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## organisationGroupsUpdateOrganisationGroupPut

> BooleanApiResponse organisationGroupsUpdateOrganisationGroupPut(saveOrganisationGroupRequest)

Update an organisation group.    Requires the &#39;ManageOrganisationGroups&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.OrganisationGroupsApi;

OrganisationGroupsApi apiInstance = new OrganisationGroupsApi();
SaveOrganisationGroupRequest saveOrganisationGroupRequest = new SaveOrganisationGroupRequest(); // SaveOrganisationGroupRequest | A Save OrganisationGroup Request object containing updated fields.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update
try {
    BooleanApiResponse result = apiInstance.organisationGroupsUpdateOrganisationGroupPut(saveOrganisationGroupRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling OrganisationGroupsApi#organisationGroupsUpdateOrganisationGroupPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **saveOrganisationGroupRequest** | [**SaveOrganisationGroupRequest**](SaveOrganisationGroupRequest.md)| A Save OrganisationGroup Request object containing updated fields.  Make sure to specify the OrganisationGroup Id in the request object so that ChronoSheets knows which OrganisationGroup to update | [optional]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

