# ProjectsApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**projectsCreateProjectPost**](ProjectsApi.md#projectsCreateProjectPost) | **POST** /Projects/CreateProject | Create a project.    Requires the &#39;ManageClientsAndProjects&#39; permission.
[**projectsGetProjectByIdGet**](ProjectsApi.md#projectsGetProjectByIdGet) | **GET** /Projects/GetProjectById | Get a project by its Id.    Requires the &#39;ManageClientsAndProjects&#39; or &#39;ManageJobsAndTask&#39; permissions.
[**projectsGetProjectsForClientGet**](ProjectsApi.md#projectsGetProjectsForClientGet) | **GET** /Projects/GetProjectsForClient | Get projects for a particular client.    Requires the &#39;ManageClientsAndProjects&#39; or &#39;ManageJobsAndTask&#39; permissions.
[**projectsUpdateProjectPut**](ProjectsApi.md#projectsUpdateProjectPut) | **PUT** /Projects/UpdateProject | Update a project.    Requires the &#39;ManageClientsAndProjects&#39; permission.



## projectsCreateProjectPost

> Int32ApiResponse projectsCreateProjectPost(insertProjectRequest)

Create a project.    Requires the &#39;ManageClientsAndProjects&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ProjectsApi;

ProjectsApi apiInstance = new ProjectsApi();
InsertProjectRequest insertProjectRequest = new InsertProjectRequest(); // InsertProjectRequest | An Insert Project Request object containing values for the new Project to create.  Make sure to specify a correct Client Id - this will be used to attach the new project under that client.
try {
    Int32ApiResponse result = apiInstance.projectsCreateProjectPost(insertProjectRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProjectsApi#projectsCreateProjectPost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertProjectRequest** | [**InsertProjectRequest**](InsertProjectRequest.md)| An Insert Project Request object containing values for the new Project to create.  Make sure to specify a correct Client Id - this will be used to attach the new project under that client. | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## projectsGetProjectByIdGet

> ProjectApiResponse projectsGetProjectByIdGet(projectId)

Get a project by its Id.    Requires the &#39;ManageClientsAndProjects&#39; or &#39;ManageJobsAndTask&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ProjectsApi;

ProjectsApi apiInstance = new ProjectsApi();
Integer projectId = null; // Integer | The ID of the Project you want to get
try {
    ProjectApiResponse result = apiInstance.projectsGetProjectByIdGet(projectId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProjectsApi#projectsGetProjectByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **projectId** | **Integer**| The ID of the Project you want to get | [optional] [default to null]

### Return type

[**ProjectApiResponse**](ProjectApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## projectsGetProjectsForClientGet

> ProjectListApiResponse projectsGetProjectsForClientGet(clientId)

Get projects for a particular client.    Requires the &#39;ManageClientsAndProjects&#39; or &#39;ManageJobsAndTask&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ProjectsApi;

ProjectsApi apiInstance = new ProjectsApi();
Integer clientId = null; // Integer | The ID of the client
try {
    ProjectListApiResponse result = apiInstance.projectsGetProjectsForClientGet(clientId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProjectsApi#projectsGetProjectsForClientGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **clientId** | **Integer**| The ID of the client | [optional] [default to null]

### Return type

[**ProjectListApiResponse**](ProjectListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## projectsUpdateProjectPut

> BooleanApiResponse projectsUpdateProjectPut(updateProjectRequest)

Update a project.    Requires the &#39;ManageClientsAndProjects&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ProjectsApi;

ProjectsApi apiInstance = new ProjectsApi();
UpdateProjectRequest updateProjectRequest = new UpdateProjectRequest(); // UpdateProjectRequest | An Update Project Request object containing updated fields.  Make sure to specify the Project Id in the request object so that ChronoSheets knows which Project to update
try {
    BooleanApiResponse result = apiInstance.projectsUpdateProjectPut(updateProjectRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ProjectsApi#projectsUpdateProjectPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateProjectRequest** | [**UpdateProjectRequest**](UpdateProjectRequest.md)| An Update Project Request object containing updated fields.  Make sure to specify the Project Id in the request object so that ChronoSheets knows which Project to update | [optional]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

