# QRCodesApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**qRCodesCreateQRCodePost**](QRCodesApi.md#qRCodesCreateQRCodePost) | **POST** /QRCodes/CreateQRCode | Create a QR codes with rules to be used for clock on/off automation.  Requires the &#39;ManageQRCodes&#39; permission.
[**qRCodesDeleteQRCodeDelete**](QRCodesApi.md#qRCodesDeleteQRCodeDelete) | **DELETE** /QRCodes/DeleteQRCode | Deletes a QR code.  Requires the &#39;ManageQRCodes&#39; permission.
[**qRCodesGetQRCodeByIdGet**](QRCodesApi.md#qRCodesGetQRCodeByIdGet) | **GET** /QRCodes/GetQRCodeById | Get a QR code by ID  Requires the &#39;SubmitTimesheets&#39; permission.
[**qRCodesGetQRCodesBasicInfoGet**](QRCodesApi.md#qRCodesGetQRCodesBasicInfoGet) | **GET** /QRCodes/GetQRCodesBasicInfo | Gets a list of all QR codes in your organisation, including just the name and ID.
[**qRCodesGetQRCodesGet**](QRCodesApi.md#qRCodesGetQRCodesGet) | **GET** /QRCodes/GetQRCodes | Get QR codes belonging to your organisation  Requires the &#39;SubmitTimesheets&#39; permission.
[**qRCodesUpdateQRCodePut**](QRCodesApi.md#qRCodesUpdateQRCodePut) | **PUT** /QRCodes/UpdateQRCode | Updates a QR code with rules to be used for clock on/off automation.  Requires the &#39;ManageQRCodes&#39; permission.



## qRCodesCreateQRCodePost

> Int32ApiResponse qRCodesCreateQRCodePost(createQRCodeRequest)

Create a QR codes with rules to be used for clock on/off automation.  Requires the &#39;ManageQRCodes&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.QRCodesApi;

QRCodesApi apiInstance = new QRCodesApi();
CreateQRCodeRequest createQRCodeRequest = new CreateQRCodeRequest(); // CreateQRCodeRequest | 
try {
    Int32ApiResponse result = apiInstance.qRCodesCreateQRCodePost(createQRCodeRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QRCodesApi#qRCodesCreateQRCodePost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **createQRCodeRequest** | [**CreateQRCodeRequest**](CreateQRCodeRequest.md)|  | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## qRCodesDeleteQRCodeDelete

> QRCodeApiResponse qRCodesDeleteQRCodeDelete(qRCodeId)

Deletes a QR code.  Requires the &#39;ManageQRCodes&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.QRCodesApi;

QRCodesApi apiInstance = new QRCodesApi();
Integer qRCodeId = null; // Integer | Specify the QR code you want to delete with the QR code ID.
try {
    QRCodeApiResponse result = apiInstance.qRCodesDeleteQRCodeDelete(qRCodeId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QRCodesApi#qRCodesDeleteQRCodeDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **qRCodeId** | **Integer**| Specify the QR code you want to delete with the QR code ID. | [optional] [default to null]

### Return type

[**QRCodeApiResponse**](QRCodeApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## qRCodesGetQRCodeByIdGet

> QRCodeApiResponse qRCodesGetQRCodeByIdGet(qRCodeId)

Get a QR code by ID  Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.QRCodesApi;

QRCodesApi apiInstance = new QRCodesApi();
Integer qRCodeId = null; // Integer | The ID of the QR code you want to obtain
try {
    QRCodeApiResponse result = apiInstance.qRCodesGetQRCodeByIdGet(qRCodeId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QRCodesApi#qRCodesGetQRCodeByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **qRCodeId** | **Integer**| The ID of the QR code you want to obtain | [optional] [default to null]

### Return type

[**QRCodeApiResponse**](QRCodeApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## qRCodesGetQRCodesBasicInfoGet

> BasicQRCodeListApiResponseForPaginated qRCodesGetQRCodesBasicInfoGet()

Gets a list of all QR codes in your organisation, including just the name and ID.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.QRCodesApi;

QRCodesApi apiInstance = new QRCodesApi();
try {
    BasicQRCodeListApiResponseForPaginated result = apiInstance.qRCodesGetQRCodesBasicInfoGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QRCodesApi#qRCodesGetQRCodesBasicInfoGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**BasicQRCodeListApiResponseForPaginated**](BasicQRCodeListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## qRCodesGetQRCodesGet

> ExtendedQRCodeListApiResponseForPaginated qRCodesGetQRCodesGet(skip, take)

Get QR codes belonging to your organisation  Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.QRCodesApi;

QRCodesApi apiInstance = new QRCodesApi();
Integer skip = 0; // Integer | Number of records to skip
Integer take = 20; // Integer | Number of records to take
try {
    ExtendedQRCodeListApiResponseForPaginated result = apiInstance.qRCodesGetQRCodesGet(skip, take);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QRCodesApi#qRCodesGetQRCodesGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **skip** | **Integer**| Number of records to skip | [optional] [default to 0]
 **take** | **Integer**| Number of records to take | [optional] [default to 20]

### Return type

[**ExtendedQRCodeListApiResponseForPaginated**](ExtendedQRCodeListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## qRCodesUpdateQRCodePut

> Int32ApiResponse qRCodesUpdateQRCodePut(updateQRCodeRequest)

Updates a QR code with rules to be used for clock on/off automation.  Requires the &#39;ManageQRCodes&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.QRCodesApi;

QRCodesApi apiInstance = new QRCodesApi();
UpdateQRCodeRequest updateQRCodeRequest = new UpdateQRCodeRequest(); // UpdateQRCodeRequest | 
try {
    Int32ApiResponse result = apiInstance.qRCodesUpdateQRCodePut(updateQRCodeRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling QRCodesApi#qRCodesUpdateQRCodePut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateQRCodeRequest** | [**UpdateQRCodeRequest**](UpdateQRCodeRequest.md)|  | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

