# ReportsApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**reportsGetAllChartsDataAdminGet**](ReportsApi.md#reportsGetAllChartsDataAdminGet) | **GET** /Reports/GetAllChartsDataAdmin | Get Consolidated Admin Reports Data (Jobs, Tasks, Clients and Projects).  These are the organisation wide reports, with data from potentially all employees.    Requires the &#39;ReportAdmin&#39; permission.
[**reportsGetAllChartsDataUserGet**](ReportsApi.md#reportsGetAllChartsDataUserGet) | **GET** /Reports/GetAllChartsDataUser | Get Consolidated User Reports Data (Jobs, Tasks, Clients and Projects).  These are the user&#39;s own reports.    Requires the &#39;ViewOwnReports&#39; permission.
[**reportsGetFleetSummaryAdminGet**](ReportsApi.md#reportsGetFleetSummaryAdminGet) | **GET** /Reports/GetFleetSummaryAdmin | Gets a summary report, which includes total distance travelled and total running costs, for vehicles within your organisation  Requires the &#39;ReportAdmin&#39; permission.
[**reportsGetOrgTripByIdGet**](ReportsApi.md#reportsGetOrgTripByIdGet) | **GET** /Reports/GetOrgTripById | Get trip by Id, for reporting purposes.    Requires the &#39;ReportAdmin&#39; permission.
[**reportsGetOrganisationTimesheetFileAttachmentsGet**](ReportsApi.md#reportsGetOrganisationTimesheetFileAttachmentsGet) | **GET** /Reports/GetOrganisationTimesheetFileAttachments | Reports on Organisation timesheet file attachments (files uploaded and attached to timesheet records)  Requires the &#39;ReportAdmin&#39; permission.
[**reportsGetOrganisationTranscriptsGet**](ReportsApi.md#reportsGetOrganisationTranscriptsGet) | **GET** /Reports/GetOrganisationTranscripts | Reports on Organisation transcripts (When an audio file is attached, it will be automatically transcribed, these are the transcriptions)    Requires the &#39;ReportAdmin&#39; permission.
[**reportsGetOrganisationTripsGet**](ReportsApi.md#reportsGetOrganisationTripsGet) | **GET** /Reports/GetOrganisationTrips | Reports on Organisation trips (GPS tracking from whole organisation).    Requires the &#39;ReportAdmin&#39; permission.
[**reportsGetRawDataAdminGet**](ReportsApi.md#reportsGetRawDataAdminGet) | **GET** /Reports/GetRawDataAdmin | Get Timesheets Raw Data.  This data details each timesheet record.  These are the organisation wide timesheet records, with data from potentially all employees.    Requires the &#39;ReportAdmin&#39; permission.
[**reportsProjectCostingsAdminGet**](ReportsApi.md#reportsProjectCostingsAdminGet) | **GET** /Reports/ProjectCostingsAdmin | Gets project cost estimations VS actual cost for date range and users.    Requires the &#39;ReportAdmin&#39; permission.
[**reportsUserJobsOverTimeGet**](ReportsApi.md#reportsUserJobsOverTimeGet) | **GET** /Reports/UserJobsOverTime | Timeseries jobs data for the logged in user.    Requires the &#39;ViewOwnReports&#39; or &#39;SubmitTimesheets&#39;.



## reportsGetAllChartsDataAdminGet

> CombinedReportsDataApiResponse reportsGetAllChartsDataAdminGet(startDate, endDate, userIds, forceOnlyThisChart)

Get Consolidated Admin Reports Data (Jobs, Tasks, Clients and Projects).  These are the organisation wide reports, with data from potentially all employees.    Requires the &#39;ReportAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
String userIds = ; // String | A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
ForcedReportFromAllReports forceOnlyThisChart = null; // ForcedReportFromAllReports | A flag to indicate which report data you require.  Choose a particular set of data, or if you want all data use the 'NotForced' option.
try {
    CombinedReportsDataApiResponse result = apiInstance.reportsGetAllChartsDataAdminGet(startDate, endDate, userIds, forceOnlyThisChart);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsGetAllChartsDataAdminGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]
 **userIds** | **String**| A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string. | [optional] [default to ]
 **forceOnlyThisChart** | [**ForcedReportFromAllReports**](.md)| A flag to indicate which report data you require.  Choose a particular set of data, or if you want all data use the &#39;NotForced&#39; option. | [optional] [default to null] [enum: NotForced, SeriesJobCodes, SeriesClients, SeriesProjects, SeriesTasks, TotalsClients, TotalsJobCodes, TotalsProjects, TotalsTasks]

### Return type

[**CombinedReportsDataApiResponse**](CombinedReportsDataApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsGetAllChartsDataUserGet

> CombinedReportsDataApiResponse reportsGetAllChartsDataUserGet(startDate, endDate)

Get Consolidated User Reports Data (Jobs, Tasks, Clients and Projects).  These are the user&#39;s own reports.    Requires the &#39;ViewOwnReports&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
try {
    CombinedReportsDataApiResponse result = apiInstance.reportsGetAllChartsDataUserGet(startDate, endDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsGetAllChartsDataUserGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]

### Return type

[**CombinedReportsDataApiResponse**](CombinedReportsDataApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsGetFleetSummaryAdminGet

> FleetSummaryReportItemListApiResponse reportsGetFleetSummaryAdminGet(startDate, endDate, userIds)

Gets a summary report, which includes total distance travelled and total running costs, for vehicles within your organisation  Requires the &#39;ReportAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
String userIds = ; // String | A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
try {
    FleetSummaryReportItemListApiResponse result = apiInstance.reportsGetFleetSummaryAdminGet(startDate, endDate, userIds);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsGetFleetSummaryAdminGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]
 **userIds** | **String**| A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string. | [optional] [default to ]

### Return type

[**FleetSummaryReportItemListApiResponse**](FleetSummaryReportItemListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsGetOrgTripByIdGet

> TripApiResponse reportsGetOrgTripByIdGet(tripId)

Get trip by Id, for reporting purposes.    Requires the &#39;ReportAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Integer tripId = null; // Integer | The ID of the Trip you want to get
try {
    TripApiResponse result = apiInstance.reportsGetOrgTripByIdGet(tripId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsGetOrgTripByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tripId** | **Integer**| The ID of the Trip you want to get | [optional] [default to null]

### Return type

[**TripApiResponse**](TripApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsGetOrganisationTimesheetFileAttachmentsGet

> OrgReportTimesheetFileAttachmentListApiResponseForPaginated reportsGetOrganisationTimesheetFileAttachmentsGet(startDate, endDate, skip, take, userIds)

Reports on Organisation timesheet file attachments (files uploaded and attached to timesheet records)  Requires the &#39;ReportAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
Integer skip = 0; // Integer | Skip this many items
Integer take = 10; // Integer | Take this many items
String userIds = ; // String | A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
try {
    OrgReportTimesheetFileAttachmentListApiResponseForPaginated result = apiInstance.reportsGetOrganisationTimesheetFileAttachmentsGet(startDate, endDate, skip, take, userIds);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsGetOrganisationTimesheetFileAttachmentsGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]
 **skip** | **Integer**| Skip this many items | [optional] [default to 0]
 **take** | **Integer**| Take this many items | [optional] [default to 10]
 **userIds** | **String**| A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string. | [optional] [default to ]

### Return type

[**OrgReportTimesheetFileAttachmentListApiResponseForPaginated**](OrgReportTimesheetFileAttachmentListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsGetOrganisationTranscriptsGet

> OrgReportTranscriptListApiResponseForPaginated reportsGetOrganisationTranscriptsGet(startDate, endDate, skip, take, userIds, keywords)

Reports on Organisation transcripts (When an audio file is attached, it will be automatically transcribed, these are the transcriptions)    Requires the &#39;ReportAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
Integer skip = 0; // Integer | Skip this many items
Integer take = 10; // Integer | Take this many items
String userIds = ; // String | A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
String keywords = ; // String | Search the transcripts by keyword(s)
try {
    OrgReportTranscriptListApiResponseForPaginated result = apiInstance.reportsGetOrganisationTranscriptsGet(startDate, endDate, skip, take, userIds, keywords);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsGetOrganisationTranscriptsGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]
 **skip** | **Integer**| Skip this many items | [optional] [default to 0]
 **take** | **Integer**| Take this many items | [optional] [default to 10]
 **userIds** | **String**| A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string. | [optional] [default to ]
 **keywords** | **String**| Search the transcripts by keyword(s) | [optional] [default to ]

### Return type

[**OrgReportTranscriptListApiResponseForPaginated**](OrgReportTranscriptListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsGetOrganisationTripsGet

> OrgReportTripListApiResponseForPaginated reportsGetOrganisationTripsGet(startDate, endDate, skip, take, userIds)

Reports on Organisation trips (GPS tracking from whole organisation).    Requires the &#39;ReportAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
Integer skip = 0; // Integer | Skip this many items
Integer take = 10; // Integer | Take this many items
String userIds = ; // String | A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
try {
    OrgReportTripListApiResponseForPaginated result = apiInstance.reportsGetOrganisationTripsGet(startDate, endDate, skip, take, userIds);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsGetOrganisationTripsGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]
 **skip** | **Integer**| Skip this many items | [optional] [default to 0]
 **take** | **Integer**| Take this many items | [optional] [default to 10]
 **userIds** | **String**| A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string. | [optional] [default to ]

### Return type

[**OrgReportTripListApiResponseForPaginated**](OrgReportTripListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsGetRawDataAdminGet

> RawReportItemListApiResponseForPaginated reportsGetRawDataAdminGet(startDate, endDate, userIds, sort, order, skip, take)

Get Timesheets Raw Data.  This data details each timesheet record.  These are the organisation wide timesheet records, with data from potentially all employees.    Requires the &#39;ReportAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
String userIds = ; // String | A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
RawDataSortColumns sort = null; // RawDataSortColumns | Decide which column to sort on
SortDirection order = null; // SortDirection | Decide which direction to sort the column
Integer skip = 0; // Integer | Skip this many rows
Integer take = 10; // Integer | Take this many rows
try {
    RawReportItemListApiResponseForPaginated result = apiInstance.reportsGetRawDataAdminGet(startDate, endDate, userIds, sort, order, skip, take);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsGetRawDataAdminGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]
 **userIds** | **String**| A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string. | [optional] [default to ]
 **sort** | [**RawDataSortColumns**](.md)| Decide which column to sort on | [optional] [default to null] [enum: EmailAddress, JobCode, TaskName, ClientName, ProjectName, StartDate, EndDate, SpanSeconds, Description, PayAmount, PayOvertimeAmount, TripCost, TripDistanceMeters, Username]
 **order** | [**SortDirection**](.md)| Decide which direction to sort the column | [optional] [default to null] [enum: Ascending, Descending]
 **skip** | **Integer**| Skip this many rows | [optional] [default to 0]
 **take** | **Integer**| Take this many rows | [optional] [default to 10]

### Return type

[**RawReportItemListApiResponseForPaginated**](RawReportItemListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsProjectCostingsAdminGet

> ProjectCostingReportItemListApiResponse reportsProjectCostingsAdminGet(startDate, endDate, userIds)

Gets project cost estimations VS actual cost for date range and users.    Requires the &#39;ReportAdmin&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
String userIds = ; // String | A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string.
try {
    ProjectCostingReportItemListApiResponse result = apiInstance.reportsProjectCostingsAdminGet(startDate, endDate, userIds);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsProjectCostingsAdminGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]
 **userIds** | **String**| A comma-separated list of user Ids, if you want to filter the report data to particular users.  If you want all, send a blank string. | [optional] [default to ]

### Return type

[**ProjectCostingReportItemListApiResponse**](ProjectCostingReportItemListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## reportsUserJobsOverTimeGet

> JobSeriesReportItemListApiResponse reportsUserJobsOverTimeGet(startDate, endDate)

Timeseries jobs data for the logged in user.    Requires the &#39;ViewOwnReports&#39; or &#39;SubmitTimesheets&#39;.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.ReportsApi;

ReportsApi apiInstance = new ReportsApi();
Date startDate = null; // Date | The start date for the date range.  Report data in the response is after this date
Date endDate = null; // Date | The end date for the date range.  Report data in the response is before this date
try {
    JobSeriesReportItemListApiResponse result = apiInstance.reportsUserJobsOverTimeGet(startDate, endDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling ReportsApi#reportsUserJobsOverTimeGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date for the date range.  Report data in the response is after this date | [optional] [default to null]
 **endDate** | **Date**| The end date for the date range.  Report data in the response is before this date | [optional] [default to null]

### Return type

[**JobSeriesReportItemListApiResponse**](JobSeriesReportItemListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

