# TasksApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**tasksCreateTaskPost**](TasksApi.md#tasksCreateTaskPost) | **POST** /Tasks/CreateTask | Create a task.    Requires the &#39;ManageJobsAndTask&#39; permission.
[**tasksDeleteTaskDelete**](TasksApi.md#tasksDeleteTaskDelete) | **DELETE** /Tasks/DeleteTask | Delete a task.    Requires the &#39;ManageJobsAndTask&#39; permission.
[**tasksGetTaskByIdGet**](TasksApi.md#tasksGetTaskByIdGet) | **GET** /Tasks/GetTaskById | Get a particular task by Id.   Requires the &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTask&#39; permissions.
[**tasksGetTasksForJobGet**](TasksApi.md#tasksGetTasksForJobGet) | **GET** /Tasks/GetTasksForJob | Get a collection of tasks for a particular Job, specified by JobId.    Requires the &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTask&#39; permissions.
[**tasksGetTasksGet**](TasksApi.md#tasksGetTasksGet) | **GET** /Tasks/GetTasks | Get tasks in your organisation.   Requires the &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTask&#39; permissions.
[**tasksUpdateTaskPut**](TasksApi.md#tasksUpdateTaskPut) | **PUT** /Tasks/UpdateTask | Update a task.    Requires the &#39;ManageJobsAndTask&#39; permission.



## tasksCreateTaskPost

> Int32ApiResponse tasksCreateTaskPost(insertTaskRequest)

Create a task.    Requires the &#39;ManageJobsAndTask&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TasksApi;

TasksApi apiInstance = new TasksApi();
InsertTaskRequest insertTaskRequest = new InsertTaskRequest(); // InsertTaskRequest | An Insert Task Request object containing values for the new Task to create
try {
    Int32ApiResponse result = apiInstance.tasksCreateTaskPost(insertTaskRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TasksApi#tasksCreateTaskPost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertTaskRequest** | [**InsertTaskRequest**](InsertTaskRequest.md)| An Insert Task Request object containing values for the new Task to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## tasksDeleteTaskDelete

> BooleanApiResponse tasksDeleteTaskDelete(taskId)

Delete a task.    Requires the &#39;ManageJobsAndTask&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TasksApi;

TasksApi apiInstance = new TasksApi();
Integer taskId = null; // Integer | The ID of the Task you want to delete
try {
    BooleanApiResponse result = apiInstance.tasksDeleteTaskDelete(taskId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TasksApi#tasksDeleteTaskDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **taskId** | **Integer**| The ID of the Task you want to delete | [optional] [default to null]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## tasksGetTaskByIdGet

> TimesheetTaskApiResponse tasksGetTaskByIdGet(taskId)

Get a particular task by Id.   Requires the &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTask&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TasksApi;

TasksApi apiInstance = new TasksApi();
Integer taskId = null; // Integer | The ID of the TimesheetTask you want to get
try {
    TimesheetTaskApiResponse result = apiInstance.tasksGetTaskByIdGet(taskId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TasksApi#tasksGetTaskByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **taskId** | **Integer**| The ID of the TimesheetTask you want to get | [optional] [default to null]

### Return type

[**TimesheetTaskApiResponse**](TimesheetTaskApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## tasksGetTasksForJobGet

> TimesheetTaskListApiResponse tasksGetTasksForJobGet(jobId)

Get a collection of tasks for a particular Job, specified by JobId.    Requires the &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTask&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TasksApi;

TasksApi apiInstance = new TasksApi();
Integer jobId = null; // Integer | The ID of the job
try {
    TimesheetTaskListApiResponse result = apiInstance.tasksGetTasksForJobGet(jobId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TasksApi#tasksGetTasksForJobGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **jobId** | **Integer**| The ID of the job | [optional] [default to null]

### Return type

[**TimesheetTaskListApiResponse**](TimesheetTaskListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## tasksGetTasksGet

> TimesheetTaskListApiResponse tasksGetTasksGet()

Get tasks in your organisation.   Requires the &#39;SubmitTimesheets&#39; or &#39;ManageJobsAndTask&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TasksApi;

TasksApi apiInstance = new TasksApi();
try {
    TimesheetTaskListApiResponse result = apiInstance.tasksGetTasksGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TasksApi#tasksGetTasksGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**TimesheetTaskListApiResponse**](TimesheetTaskListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## tasksUpdateTaskPut

> BooleanApiResponse tasksUpdateTaskPut(updateTaskRequest)

Update a task.    Requires the &#39;ManageJobsAndTask&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TasksApi;

TasksApi apiInstance = new TasksApi();
UpdateTaskRequest updateTaskRequest = new UpdateTaskRequest(); // UpdateTaskRequest | An Update Task Request object containing updated fields.  Make sure to specify the Task Id in the request object so that ChronoSheets knows which Task to update
try {
    BooleanApiResponse result = apiInstance.tasksUpdateTaskPut(updateTaskRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TasksApi#tasksUpdateTaskPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateTaskRequest** | [**UpdateTaskRequest**](UpdateTaskRequest.md)| An Update Task Request object containing updated fields.  Make sure to specify the Task Id in the request object so that ChronoSheets knows which Task to update | [optional]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

