# TimesheetAutomationApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**timesheetAutomationCreateAutomationStepPost**](TimesheetAutomationApi.md#timesheetAutomationCreateAutomationStepPost) | **POST** /TimesheetAutomation/CreateAutomationStep | Creates an automation step.  Timesheet automation is determined by looking at steps taken by the user.  Create a step to log some automation action, such as entering a geofence, scanning a QR Code or tapping on an NFC badge.  Requires the &#39;SubmitTimesheets&#39; permission.
[**timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet**](TimesheetAutomationApi.md#timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet) | **GET** /TimesheetAutomation/GetTimesheetAutomationGeofenceAuditTrail | Retrieve the timesheet automation / alerts for geofences activities  Requires the &#39;ManageGeofencing&#39; permission.
[**timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet**](TimesheetAutomationApi.md#timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet) | **GET** /TimesheetAutomation/GetTimesheetAutomationNFCTagAuditTrail | Retrieve the timesheet automation / alerts for NFC tag activities  Requires the &#39;ManageNFCCodes&#39; permission.
[**timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet**](TimesheetAutomationApi.md#timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet) | **GET** /TimesheetAutomation/GetTimesheetAutomationQRCodeAuditTrail | Retrieve the timesheet automation / alerts for QR Code activities  Requires the &#39;ManageQRCodes&#39; permission.



## timesheetAutomationCreateAutomationStepPost

> Int32ApiResponse timesheetAutomationCreateAutomationStepPost(createAutomationStepRequest)

Creates an automation step.  Timesheet automation is determined by looking at steps taken by the user.  Create a step to log some automation action, such as entering a geofence, scanning a QR Code or tapping on an NFC badge.  Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TimesheetAutomationApi;

TimesheetAutomationApi apiInstance = new TimesheetAutomationApi();
CreateAutomationStepRequest createAutomationStepRequest = new CreateAutomationStepRequest(); // CreateAutomationStepRequest | 
try {
    Int32ApiResponse result = apiInstance.timesheetAutomationCreateAutomationStepPost(createAutomationStepRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TimesheetAutomationApi#timesheetAutomationCreateAutomationStepPost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **createAutomationStepRequest** | [**CreateAutomationStepRequest**](CreateAutomationStepRequest.md)|  | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet

> TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet(geofenceId, userId, sort, order, skip, take)

Retrieve the timesheet automation / alerts for geofences activities  Requires the &#39;ManageGeofencing&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TimesheetAutomationApi;

TimesheetAutomationApi apiInstance = new TimesheetAutomationApi();
Integer geofenceId = null; // Integer | The ID of the Geofence
Integer userId = null; // Integer | The ID of the user
AutomationAuditDataSortColumns sort = null; // AutomationAuditDataSortColumns | The field to sort the records by
SortDirection order = null; // SortDirection | The directions to sort records by
Integer skip = 0; // Integer | Skip this many records
Integer take = 20; // Integer | Take this many records
try {
    TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated result = apiInstance.timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet(geofenceId, userId, sort, order, skip, take);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TimesheetAutomationApi#timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **geofenceId** | **Integer**| The ID of the Geofence | [optional] [default to null]
 **userId** | **Integer**| The ID of the user | [optional] [default to null]
 **sort** | [**AutomationAuditDataSortColumns**](.md)| The field to sort the records by | [optional] [default to null] [enum: UserName, AutomationActionType, ClientDateTime, IsProcessed]
 **order** | [**SortDirection**](.md)| The directions to sort records by | [optional] [default to null] [enum: Ascending, Descending]
 **skip** | **Integer**| Skip this many records | [optional] [default to 0]
 **take** | **Integer**| Take this many records | [optional] [default to 20]

### Return type

[**TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated**](TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet

> TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet(nfcTagId, userId, sort, order, skip, take)

Retrieve the timesheet automation / alerts for NFC tag activities  Requires the &#39;ManageNFCCodes&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TimesheetAutomationApi;

TimesheetAutomationApi apiInstance = new TimesheetAutomationApi();
Integer nfcTagId = null; // Integer | The ID of the NFC tag
Integer userId = null; // Integer | The ID of the user
AutomationAuditDataSortColumns sort = null; // AutomationAuditDataSortColumns | The field to sort the records by
SortDirection order = null; // SortDirection | The directions to sort records by
Integer skip = 0; // Integer | Skip this many records
Integer take = 20; // Integer | Take this many records
try {
    TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated result = apiInstance.timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet(nfcTagId, userId, sort, order, skip, take);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TimesheetAutomationApi#timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **nfcTagId** | **Integer**| The ID of the NFC tag | [optional] [default to null]
 **userId** | **Integer**| The ID of the user | [optional] [default to null]
 **sort** | [**AutomationAuditDataSortColumns**](.md)| The field to sort the records by | [optional] [default to null] [enum: UserName, AutomationActionType, ClientDateTime, IsProcessed]
 **order** | [**SortDirection**](.md)| The directions to sort records by | [optional] [default to null] [enum: Ascending, Descending]
 **skip** | **Integer**| Skip this many records | [optional] [default to 0]
 **take** | **Integer**| Take this many records | [optional] [default to 20]

### Return type

[**TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated**](TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet

> TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet(qRCodeId, userId, sort, order, skip, take)

Retrieve the timesheet automation / alerts for QR Code activities  Requires the &#39;ManageQRCodes&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TimesheetAutomationApi;

TimesheetAutomationApi apiInstance = new TimesheetAutomationApi();
Integer qRCodeId = null; // Integer | The ID of the QR Code
Integer userId = null; // Integer | The ID of the user
AutomationAuditDataSortColumns sort = null; // AutomationAuditDataSortColumns | The field to sort the records by
SortDirection order = null; // SortDirection | The directions to sort records by
Integer skip = 0; // Integer | Skip this many records
Integer take = 20; // Integer | Take this many records
try {
    TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated result = apiInstance.timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet(qRCodeId, userId, sort, order, skip, take);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TimesheetAutomationApi#timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **qRCodeId** | **Integer**| The ID of the QR Code | [optional] [default to null]
 **userId** | **Integer**| The ID of the user | [optional] [default to null]
 **sort** | [**AutomationAuditDataSortColumns**](.md)| The field to sort the records by | [optional] [default to null] [enum: UserName, AutomationActionType, ClientDateTime, IsProcessed]
 **order** | [**SortDirection**](.md)| The directions to sort records by | [optional] [default to null] [enum: Ascending, Descending]
 **skip** | **Integer**| Skip this many records | [optional] [default to 0]
 **take** | **Integer**| Take this many records | [optional] [default to 20]

### Return type

[**TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated**](TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

