# TimesheetsApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**timesheetsCreateSingleTimesheetPost**](TimesheetsApi.md#timesheetsCreateSingleTimesheetPost) | **POST** /Timesheets/CreateSingleTimesheet | Inserts a single timesheet record.    Requires the &#39;SubmitTimesheets&#39; permission.
[**timesheetsDeleteTimesheetDelete**](TimesheetsApi.md#timesheetsDeleteTimesheetDelete) | **DELETE** /Timesheets/DeleteTimesheet | Delete a timesheet.    Requires the &#39;SubmitTimesheets&#39; permission.
[**timesheetsGetTimesheetsGet**](TimesheetsApi.md#timesheetsGetTimesheetsGet) | **GET** /Timesheets/GetTimesheets | Get timesheets between start and end dates.  Note: the date range cannot exceed 24 hours.  This method is generally used to get timesheets for a particular day.    Requires the &#39;SubmitTimesheets&#39; permission.
[**timesheetsUpdateTimesheetsPut**](TimesheetsApi.md#timesheetsUpdateTimesheetsPut) | **PUT** /Timesheets/UpdateTimesheets | Batch update timesheets.    Requires the &#39;SubmitTimesheets&#39; permission.



## timesheetsCreateSingleTimesheetPost

> Int32ApiResponse timesheetsCreateSingleTimesheetPost(timesheet)

Inserts a single timesheet record.    Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TimesheetsApi;

TimesheetsApi apiInstance = new TimesheetsApi();
Timesheet timesheet = new Timesheet(); // Timesheet | A Timesheet Request object containing values for the new Timesheet to create
try {
    Int32ApiResponse result = apiInstance.timesheetsCreateSingleTimesheetPost(timesheet);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TimesheetsApi#timesheetsCreateSingleTimesheetPost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **timesheet** | [**Timesheet**](Timesheet.md)| A Timesheet Request object containing values for the new Timesheet to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## timesheetsDeleteTimesheetDelete

> BooleanApiResponse timesheetsDeleteTimesheetDelete(timesheetId)

Delete a timesheet.    Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TimesheetsApi;

TimesheetsApi apiInstance = new TimesheetsApi();
Integer timesheetId = null; // Integer | The ID of the Timesheet you want to delete
try {
    BooleanApiResponse result = apiInstance.timesheetsDeleteTimesheetDelete(timesheetId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TimesheetsApi#timesheetsDeleteTimesheetDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **timesheetId** | **Integer**| The ID of the Timesheet you want to delete | [optional] [default to null]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## timesheetsGetTimesheetsGet

> TimesheetListApiResponse timesheetsGetTimesheetsGet(startDate, endDate)

Get timesheets between start and end dates.  Note: the date range cannot exceed 24 hours.  This method is generally used to get timesheets for a particular day.    Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TimesheetsApi;

TimesheetsApi apiInstance = new TimesheetsApi();
Date startDate = null; // Date | The start date of the date range
Date endDate = null; // Date | The end date of the date range
try {
    TimesheetListApiResponse result = apiInstance.timesheetsGetTimesheetsGet(startDate, endDate);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TimesheetsApi#timesheetsGetTimesheetsGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The start date of the date range | [optional] [default to null]
 **endDate** | **Date**| The end date of the date range | [optional] [default to null]

### Return type

[**TimesheetListApiResponse**](TimesheetListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## timesheetsUpdateTimesheetsPut

> Int32ListApiResponse timesheetsUpdateTimesheetsPut(batchUpdateTimesheetRequest)

Batch update timesheets.    Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TimesheetsApi;

TimesheetsApi apiInstance = new TimesheetsApi();
BatchUpdateTimesheetRequest batchUpdateTimesheetRequest = new BatchUpdateTimesheetRequest(); // BatchUpdateTimesheetRequest | A BatchUpdateTimesheet Request object containing values for the new Timesheets to create or update.  If the timesheet Id is specified, then an update will be performed, else the timesheet record will be created.
try {
    Int32ListApiResponse result = apiInstance.timesheetsUpdateTimesheetsPut(batchUpdateTimesheetRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TimesheetsApi#timesheetsUpdateTimesheetsPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **batchUpdateTimesheetRequest** | [**BatchUpdateTimesheetRequest**](BatchUpdateTimesheetRequest.md)| A BatchUpdateTimesheet Request object containing values for the new Timesheets to create or update.  If the timesheet Id is specified, then an update will be performed, else the timesheet record will be created. | [optional]

### Return type

[**Int32ListApiResponse**](Int32ListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

