# TranscriptsApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**transcriptsGetMyTranscriptGet**](TranscriptsApi.md#transcriptsGetMyTranscriptGet) | **GET** /Transcripts/GetMyTranscript | Get an audio to text transcript for a particular audio file attachment
[**transcriptsGetMyTranscriptsGet**](TranscriptsApi.md#transcriptsGetMyTranscriptsGet) | **GET** /Transcripts/GetMyTranscripts | Get my file transcripts.  Get audio to text transcripts that you&#39;ve created.



## transcriptsGetMyTranscriptGet

> TranscriptionApiResponse transcriptsGetMyTranscriptGet(fileAttachmentId)

Get an audio to text transcript for a particular audio file attachment

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TranscriptsApi;

TranscriptsApi apiInstance = new TranscriptsApi();
Integer fileAttachmentId = null; // Integer | The ID of the file attachment that has a transcript.  It should be an audio file attachment.
try {
    TranscriptionApiResponse result = apiInstance.transcriptsGetMyTranscriptGet(fileAttachmentId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TranscriptsApi#transcriptsGetMyTranscriptGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **fileAttachmentId** | **Integer**| The ID of the file attachment that has a transcript.  It should be an audio file attachment. | [optional] [default to null]

### Return type

[**TranscriptionApiResponse**](TranscriptionApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## transcriptsGetMyTranscriptsGet

> OrgReportTranscriptListApiResponseForPaginated transcriptsGetMyTranscriptsGet(startDate, endDate, skip, take, keyword)

Get my file transcripts.  Get audio to text transcripts that you&#39;ve created.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TranscriptsApi;

TranscriptsApi apiInstance = new TranscriptsApi();
Date startDate = null; // Date | The Start date of the date range.  Transcripts after this date will be obtained.
Date endDate = null; // Date | The End date of the date range.  Transcripts before this date will be obtained.
Integer skip = 0; // Integer | Skip this many transcripts
Integer take = 10; // Integer | Take this many transcripts
String keyword = ; // String | Search the text content of the transcript keywords
try {
    OrgReportTranscriptListApiResponseForPaginated result = apiInstance.transcriptsGetMyTranscriptsGet(startDate, endDate, skip, take, keyword);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TranscriptsApi#transcriptsGetMyTranscriptsGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The Start date of the date range.  Transcripts after this date will be obtained. | [optional] [default to null]
 **endDate** | **Date**| The End date of the date range.  Transcripts before this date will be obtained. | [optional] [default to null]
 **skip** | **Integer**| Skip this many transcripts | [optional] [default to 0]
 **take** | **Integer**| Take this many transcripts | [optional] [default to 10]
 **keyword** | **String**| Search the text content of the transcript keywords | [optional] [default to ]

### Return type

[**OrgReportTranscriptListApiResponseForPaginated**](OrgReportTranscriptListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

