# TripsApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**tripsCreateTripPost**](TripsApi.md#tripsCreateTripPost) | **POST** /Trips/CreateTrip | Create a new trip.  Important: create a timesheet record before calling this, passing in the new timesheet record id as a reference.    Requires the &#39;SubmitTimesheets&#39; permission.
[**tripsGetMyTripByIdGet**](TripsApi.md#tripsGetMyTripByIdGet) | **GET** /Trips/GetMyTripById | Get trip by Id.    Requires the &#39;ViewMyTrips&#39; permission.
[**tripsGetMyTripsGet**](TripsApi.md#tripsGetMyTripsGet) | **GET** /Trips/GetMyTrips | Get my trips.  Get the GPS trips you&#39;ve recorded and submitted.    Requires the &#39;ViewMyTrips&#39; permission.



## tripsCreateTripPost

> Int32ApiResponse tripsCreateTripPost(createTripRequest)

Create a new trip.  Important: create a timesheet record before calling this, passing in the new timesheet record id as a reference.    Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TripsApi;

TripsApi apiInstance = new TripsApi();
CreateTripRequest createTripRequest = new CreateTripRequest(); // CreateTripRequest | A Create Trip Request object containing values for the new Trip to create
try {
    Int32ApiResponse result = apiInstance.tripsCreateTripPost(createTripRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TripsApi#tripsCreateTripPost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **createTripRequest** | [**CreateTripRequest**](CreateTripRequest.md)| A Create Trip Request object containing values for the new Trip to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## tripsGetMyTripByIdGet

> TripApiResponse tripsGetMyTripByIdGet(tripId)

Get trip by Id.    Requires the &#39;ViewMyTrips&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TripsApi;

TripsApi apiInstance = new TripsApi();
Integer tripId = null; // Integer | The ID of the Trip you want to get
try {
    TripApiResponse result = apiInstance.tripsGetMyTripByIdGet(tripId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TripsApi#tripsGetMyTripByIdGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **tripId** | **Integer**| The ID of the Trip you want to get | [optional] [default to null]

### Return type

[**TripApiResponse**](TripApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## tripsGetMyTripsGet

> TripListApiResponseForPaginated tripsGetMyTripsGet(startDate, endDate, skip, take, vehicleId)

Get my trips.  Get the GPS trips you&#39;ve recorded and submitted.    Requires the &#39;ViewMyTrips&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.TripsApi;

TripsApi apiInstance = new TripsApi();
Date startDate = null; // Date | The Start date of the date range.  Trips after this date will be obtained.
Date endDate = null; // Date | The End date of the date range.  Trips before this date will be obtained.
Integer skip = 0; // Integer | Skip this many Trips
Integer take = 10; // Integer | Take this many Trips
Integer vehicleId = -1; // Integer | Filter by a particular Vehicle (get trips made with a particular vehicle), specified by VehicleId
try {
    TripListApiResponseForPaginated result = apiInstance.tripsGetMyTripsGet(startDate, endDate, skip, take, vehicleId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling TripsApi#tripsGetMyTripsGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **startDate** | **Date**| The Start date of the date range.  Trips after this date will be obtained. | [optional] [default to null]
 **endDate** | **Date**| The End date of the date range.  Trips before this date will be obtained. | [optional] [default to null]
 **skip** | **Integer**| Skip this many Trips | [optional] [default to 0]
 **take** | **Integer**| Take this many Trips | [optional] [default to 10]
 **vehicleId** | **Integer**| Filter by a particular Vehicle (get trips made with a particular vehicle), specified by VehicleId | [optional] [default to -1]

### Return type

[**TripListApiResponseForPaginated**](TripListApiResponseForPaginated.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

