# UserJobFavouritesApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userJobFavouritesCreateJobFavouritePost**](UserJobFavouritesApi.md#userJobFavouritesCreateJobFavouritePost) | **POST** /UserJobFavourites/CreateJobFavourite | Create a job favourite.    Requires the &#39;SubmitTimesheets&#39; permission.
[**userJobFavouritesDeleteJobFavouriteDelete**](UserJobFavouritesApi.md#userJobFavouritesDeleteJobFavouriteDelete) | **DELETE** /UserJobFavourites/DeleteJobFavourite | Delete a job favourite.    Requires the &#39;SubmitTimesheets&#39; permission.
[**userJobFavouritesGetJobFavouritesGet**](UserJobFavouritesApi.md#userJobFavouritesGetJobFavouritesGet) | **GET** /UserJobFavourites/GetJobFavourites | Get your job favourites.    Requires the &#39;SubmitTimesheets&#39; permission.



## userJobFavouritesCreateJobFavouritePost

> Int32ApiResponse userJobFavouritesCreateJobFavouritePost(insertUserJobFavouriteRequest)

Create a job favourite.    Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserJobFavouritesApi;

UserJobFavouritesApi apiInstance = new UserJobFavouritesApi();
InsertUserJobFavouriteRequest insertUserJobFavouriteRequest = new InsertUserJobFavouriteRequest(); // InsertUserJobFavouriteRequest | An Insert UserJobFavourite Request object containing values for the new UserJobFavourite to create
try {
    Int32ApiResponse result = apiInstance.userJobFavouritesCreateJobFavouritePost(insertUserJobFavouriteRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserJobFavouritesApi#userJobFavouritesCreateJobFavouritePost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertUserJobFavouriteRequest** | [**InsertUserJobFavouriteRequest**](InsertUserJobFavouriteRequest.md)| An Insert UserJobFavourite Request object containing values for the new UserJobFavourite to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## userJobFavouritesDeleteJobFavouriteDelete

> BooleanApiResponse userJobFavouritesDeleteJobFavouriteDelete(jobId)

Delete a job favourite.    Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserJobFavouritesApi;

UserJobFavouritesApi apiInstance = new UserJobFavouritesApi();
Integer jobId = null; // Integer | The ID of the Job for the Job Favourite you want to delete.
try {
    BooleanApiResponse result = apiInstance.userJobFavouritesDeleteJobFavouriteDelete(jobId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserJobFavouritesApi#userJobFavouritesDeleteJobFavouriteDelete");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **jobId** | **Integer**| The ID of the Job for the Job Favourite you want to delete. | [optional] [default to null]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## userJobFavouritesGetJobFavouritesGet

> UserJobFavouriteListApiResponse userJobFavouritesGetJobFavouritesGet()

Get your job favourites.    Requires the &#39;SubmitTimesheets&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserJobFavouritesApi;

UserJobFavouritesApi apiInstance = new UserJobFavouritesApi();
try {
    UserJobFavouriteListApiResponse result = apiInstance.userJobFavouritesGetJobFavouritesGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserJobFavouritesApi#userJobFavouritesGetJobFavouritesGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**UserJobFavouriteListApiResponse**](UserJobFavouriteListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

