# UserPayRatesApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userPayRatesCreatePayRatePost**](UserPayRatesApi.md#userPayRatesCreatePayRatePost) | **POST** /UserPayRates/CreatePayRate | Create a new pay rate for a particular user, archiving the previous pay rate.    Requires the &#39;ManageOrganisationUsers&#39; permission.
[**userPayRatesGetPayRatesGet**](UserPayRatesApi.md#userPayRatesGetPayRatesGet) | **GET** /UserPayRates/GetPayRates | Get a collection of pay rates for a particular user, specified by user id.    Requires the &#39;ManageOrganisationUsers&#39; permission.



## userPayRatesCreatePayRatePost

> Int32ApiResponse userPayRatesCreatePayRatePost(insertUserHourlyRateRequest)

Create a new pay rate for a particular user, archiving the previous pay rate.    Requires the &#39;ManageOrganisationUsers&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserPayRatesApi;

UserPayRatesApi apiInstance = new UserPayRatesApi();
InsertUserHourlyRateRequest insertUserHourlyRateRequest = new InsertUserHourlyRateRequest(); // InsertUserHourlyRateRequest | An Insert UserHourlyRate Request object containing values for the new UserHourlyRate to create
try {
    Int32ApiResponse result = apiInstance.userPayRatesCreatePayRatePost(insertUserHourlyRateRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserPayRatesApi#userPayRatesCreatePayRatePost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertUserHourlyRateRequest** | [**InsertUserHourlyRateRequest**](InsertUserHourlyRateRequest.md)| An Insert UserHourlyRate Request object containing values for the new UserHourlyRate to create | [optional]

### Return type

[**Int32ApiResponse**](Int32ApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## userPayRatesGetPayRatesGet

> UserHourlyRateListApiResponse userPayRatesGetPayRatesGet(userId)

Get a collection of pay rates for a particular user, specified by user id.    Requires the &#39;ManageOrganisationUsers&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserPayRatesApi;

UserPayRatesApi apiInstance = new UserPayRatesApi();
Integer userId = null; // Integer | The ID of the User for which you want to get UserHourlyRate objects
try {
    UserHourlyRateListApiResponse result = apiInstance.userPayRatesGetPayRatesGet(userId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserPayRatesApi#userPayRatesGetPayRatesGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userId** | **Integer**| The ID of the User for which you want to get UserHourlyRate objects | [optional] [default to null]

### Return type

[**UserHourlyRateListApiResponse**](UserHourlyRateListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json

