# UserProfileApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userProfileDoLoginPut**](UserProfileApi.md#userProfileDoLoginPut) | **PUT** /UserProfile/DoLogin | Login to your ChronoSheets account and obtain an Auth Token which you can use for other ChronoSheets API methods.    Does not require any special permissions.
[**userProfileDoLogoutDelete**](UserProfileApi.md#userProfileDoLogoutDelete) | **DELETE** /UserProfile/DoLogout | Logout of your ChronoSheets account.  This method ends and deletes your active session.    Does not require any special permissions.
[**userProfileGetMyProfileGet**](UserProfileApi.md#userProfileGetMyProfileGet) | **GET** /UserProfile/GetMyProfile | Get your own profile.  Use this method to obtain detailed information about your ChronoSheets user profile.    Does not require any special permissions.
[**userProfileKeepSessionAliveGet**](UserProfileApi.md#userProfileKeepSessionAliveGet) | **GET** /UserProfile/KeepSessionAlive | Keep a session alive.  Use this method to keep a session active.  You could use this to &#39;ping&#39; ChronoSheets every &#39;x&#39; minutes to make sure your Auth Token will keep working.    Does not require any special permissions.
[**userProfileUpdateMyProfilePut**](UserProfileApi.md#userProfileUpdateMyProfilePut) | **PUT** /UserProfile/UpdateMyProfile | Update your own profile.  Use this method to update your profile information or update/change your password.    Does not require any special permissions.



## userProfileDoLoginPut

> DoLoginResponseApiResponse userProfileDoLoginPut(doLoginRequest)

Login to your ChronoSheets account and obtain an Auth Token which you can use for other ChronoSheets API methods.    Does not require any special permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserProfileApi;

UserProfileApi apiInstance = new UserProfileApi();
DoLoginRequest doLoginRequest = new DoLoginRequest(); // DoLoginRequest | A request object containing your username/email and password.
try {
    DoLoginResponseApiResponse result = apiInstance.userProfileDoLoginPut(doLoginRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserProfileApi#userProfileDoLoginPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **doLoginRequest** | [**DoLoginRequest**](DoLoginRequest.md)| A request object containing your username/email and password. | [optional]

### Return type

[**DoLoginResponseApiResponse**](DoLoginResponseApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## userProfileDoLogoutDelete

> BooleanApiResponse userProfileDoLogoutDelete()

Logout of your ChronoSheets account.  This method ends and deletes your active session.    Does not require any special permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserProfileApi;

UserProfileApi apiInstance = new UserProfileApi();
try {
    BooleanApiResponse result = apiInstance.userProfileDoLogoutDelete();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserProfileApi#userProfileDoLogoutDelete");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## userProfileGetMyProfileGet

> UserProfileApiResponse userProfileGetMyProfileGet()

Get your own profile.  Use this method to obtain detailed information about your ChronoSheets user profile.    Does not require any special permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserProfileApi;

UserProfileApi apiInstance = new UserProfileApi();
try {
    UserProfileApiResponse result = apiInstance.userProfileGetMyProfileGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserProfileApi#userProfileGetMyProfileGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**UserProfileApiResponse**](UserProfileApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## userProfileKeepSessionAliveGet

> BooleanApiResponse userProfileKeepSessionAliveGet()

Keep a session alive.  Use this method to keep a session active.  You could use this to &#39;ping&#39; ChronoSheets every &#39;x&#39; minutes to make sure your Auth Token will keep working.    Does not require any special permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserProfileApi;

UserProfileApi apiInstance = new UserProfileApi();
try {
    BooleanApiResponse result = apiInstance.userProfileKeepSessionAliveGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserProfileApi#userProfileKeepSessionAliveGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## userProfileUpdateMyProfilePut

> UpdateProfileResponseApiResponse userProfileUpdateMyProfilePut(updateMyProfileRequest)

Update your own profile.  Use this method to update your profile information or update/change your password.    Does not require any special permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UserProfileApi;

UserProfileApi apiInstance = new UserProfileApi();
UpdateMyProfileRequest updateMyProfileRequest = new UpdateMyProfileRequest(); // UpdateMyProfileRequest | An Update MyProfile Request object containing updated fields.
try {
    UpdateProfileResponseApiResponse result = apiInstance.userProfileUpdateMyProfilePut(updateMyProfileRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserProfileApi#userProfileUpdateMyProfilePut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateMyProfileRequest** | [**UpdateMyProfileRequest**](UpdateMyProfileRequest.md)| An Update MyProfile Request object containing updated fields. | [optional]

### Return type

[**UpdateProfileResponseApiResponse**](UpdateProfileResponseApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

