# UsersApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**usersCreateTimesheetUserPost**](UsersApi.md#usersCreateTimesheetUserPost) | **POST** /Users/CreateTimesheetUser | Create a user account in your organisation.  Requires the &#39;ManageOrganisationUsers&#39; permission.
[**usersGetTimesheetUserGet**](UsersApi.md#usersGetTimesheetUserGet) | **GET** /Users/GetTimesheetUser | Get a particular user in your organisation.  Requires the &#39;ManageOrganisationUsers&#39; or &#39;ManageOrganisationGroups&#39; permissions.
[**usersGetTimesheetUsersGet**](UsersApi.md#usersGetTimesheetUsersGet) | **GET** /Users/GetTimesheetUsers | Get users accounts in your organisation.  Requires the &#39;ManageOrganisationUsers&#39; or &#39;ManageOrganisationGroups&#39; permissions.
[**usersUpdateTimesheetUserPut**](UsersApi.md#usersUpdateTimesheetUserPut) | **PUT** /Users/UpdateTimesheetUser | Update a user account.  Requires the &#39;ManageOrganisationUsers&#39; permission.



## usersCreateTimesheetUserPost

> InsertUserResponseApiResponse usersCreateTimesheetUserPost(insertUserRequest)

Create a user account in your organisation.  Requires the &#39;ManageOrganisationUsers&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UsersApi;

UsersApi apiInstance = new UsersApi();
InsertUserRequest insertUserRequest = new InsertUserRequest(); // InsertUserRequest | An Insert User Request object containing values for the new User to create
try {
    InsertUserResponseApiResponse result = apiInstance.usersCreateTimesheetUserPost(insertUserRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UsersApi#usersCreateTimesheetUserPost");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **insertUserRequest** | [**InsertUserRequest**](InsertUserRequest.md)| An Insert User Request object containing values for the new User to create | [optional]

### Return type

[**InsertUserResponseApiResponse**](InsertUserResponseApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json


## usersGetTimesheetUserGet

> UserForManagementApiResponse usersGetTimesheetUserGet(userId)

Get a particular user in your organisation.  Requires the &#39;ManageOrganisationUsers&#39; or &#39;ManageOrganisationGroups&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UsersApi;

UsersApi apiInstance = new UsersApi();
Integer userId = null; // Integer | The User ID of the UserForManagement you want to get
try {
    UserForManagementApiResponse result = apiInstance.usersGetTimesheetUserGet(userId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UsersApi#usersGetTimesheetUserGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userId** | **Integer**| The User ID of the UserForManagement you want to get | [optional] [default to null]

### Return type

[**UserForManagementApiResponse**](UserForManagementApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## usersGetTimesheetUsersGet

> UserForManagementListApiResponse usersGetTimesheetUsersGet()

Get users accounts in your organisation.  Requires the &#39;ManageOrganisationUsers&#39; or &#39;ManageOrganisationGroups&#39; permissions.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UsersApi;

UsersApi apiInstance = new UsersApi();
try {
    UserForManagementListApiResponse result = apiInstance.usersGetTimesheetUsersGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UsersApi#usersGetTimesheetUsersGet");
    e.printStackTrace();
}
```

### Parameters

This endpoint does not need any parameter.

### Return type

[**UserForManagementListApiResponse**](UserForManagementListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## usersUpdateTimesheetUserPut

> UpdateUserResponseApiResponse usersUpdateTimesheetUserPut(updateUserRequest)

Update a user account.  Requires the &#39;ManageOrganisationUsers&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UsersApi;

UsersApi apiInstance = new UsersApi();
UpdateUserRequest updateUserRequest = new UpdateUserRequest(); // UpdateUserRequest | A Update User Request object containing updated fields.  Make sure to specify the User Id in the request object so that ChronoSheets knows which User to update
try {
    UpdateUserResponseApiResponse result = apiInstance.usersUpdateTimesheetUserPut(updateUserRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UsersApi#usersUpdateTimesheetUserPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **updateUserRequest** | [**UpdateUserRequest**](UpdateUserRequest.md)| A Update User Request object containing updated fields.  Make sure to specify the User Id in the request object so that ChronoSheets knows which User to update | [optional]

### Return type

[**UpdateUserResponseApiResponse**](UpdateUserResponseApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

