# UsualHoursApi

All URIs are relative to *https://api.chronosheets.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**usualHoursGetUsualHoursGet**](UsualHoursApi.md#usualHoursGetUsualHoursGet) | **GET** /UsualHours/GetUsualHours | Get usual hours (rostered hours) for an employee.  Requires the &#39;ManageOrganisationUsers&#39; permission.
[**usualHoursSetUsualHoursPut**](UsualHoursApi.md#usualHoursSetUsualHoursPut) | **PUT** /UsualHours/SetUsualHours | Set usual hours (rostered hours) for an employee.  Requires the &#39;ManageOrganisationUsers&#39; permission.



## usualHoursGetUsualHoursGet

> UsualHoursDayListApiResponse usualHoursGetUsualHoursGet(userId)

Get usual hours (rostered hours) for an employee.  Requires the &#39;ManageOrganisationUsers&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UsualHoursApi;

UsualHoursApi apiInstance = new UsualHoursApi();
Integer userId = null; // Integer | The ID of the User for which you want to get UsualHours for
try {
    UsualHoursDayListApiResponse result = apiInstance.usualHoursGetUsualHoursGet(userId);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UsualHoursApi#usualHoursGetUsualHoursGet");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **userId** | **Integer**| The ID of the User for which you want to get UsualHours for | [optional] [default to null]

### Return type

[**UsualHoursDayListApiResponse**](UsualHoursDayListApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: Not defined
- **Accept**: application/json


## usualHoursSetUsualHoursPut

> BooleanApiResponse usualHoursSetUsualHoursPut(setUsualHoursRequest)

Set usual hours (rostered hours) for an employee.  Requires the &#39;ManageOrganisationUsers&#39; permission.

### Example

```java
// Import classes:
//import ChronoSheetsClientLibApi.UsualHoursApi;

UsualHoursApi apiInstance = new UsualHoursApi();
SetUsualHoursRequest setUsualHoursRequest = new SetUsualHoursRequest(); // SetUsualHoursRequest | A Set UsualHours Request object containing updated data.  Make sure to specify the Day types in the request object so that ChronoSheets knows which Days to update
try {
    BooleanApiResponse result = apiInstance.usualHoursSetUsualHoursPut(setUsualHoursRequest);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UsualHoursApi#usualHoursSetUsualHoursPut");
    e.printStackTrace();
}
```

### Parameters


Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **setUsualHoursRequest** | [**SetUsualHoursRequest**](SetUsualHoursRequest.md)| A Set UsualHours Request object containing updated data.  Make sure to specify the Day types in the request object so that ChronoSheets knows which Days to update | [optional]

### Return type

[**BooleanApiResponse**](BooleanApiResponse.md)

### Authorization

[x-chronosheets-auth](../README.md#x-chronosheets-auth)

### HTTP request headers

- **Content-Type**: application/json
- **Accept**: application/json

