/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibApi;

import ChronoSheetsClient.ApiInvoker;
import ChronoSheetsClient.ApiException;
import ChronoSheetsClient.Pair;

import ChronoSheetsClientLibModel.*;

import java.util.*;

import com.android.volley.Response;
import com.android.volley.VolleyError;

import ChronoSheetsClientLibModel.AutomationAuditDataSortColumns;
import ChronoSheetsClientLibModel.CreateAutomationStepRequest;
import ChronoSheetsClientLibModel.Int32ApiResponse;
import ChronoSheetsClientLibModel.SortDirection;
import ChronoSheetsClientLibModel.TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated;
import ChronoSheetsClientLibModel.TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated;
import ChronoSheetsClientLibModel.TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated;

import org.apache.http.HttpEntity;
import org.apache.http.entity.mime.MultipartEntityBuilder;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.concurrent.ExecutionException;
import java.util.concurrent.TimeoutException;

public class TimesheetAutomationApi {
  String basePath = "https://api.chronosheets.com";
  ApiInvoker apiInvoker = ApiInvoker.getInstance();

  public void addHeader(String key, String value) {
    getInvoker().addDefaultHeader(key, value);
  }

  public ApiInvoker getInvoker() {
    return apiInvoker;
  }

  public void setBasePath(String basePath) {
    this.basePath = basePath;
  }

  public String getBasePath() {
    return basePath;
  }

  /**
  * Creates an automation step.  Timesheet automation is determined by looking at steps taken by the user.  Create a step to log some automation action, such as entering a geofence, scanning a QR Code or tapping on an NFC badge.  Requires the &#39;SubmitTimesheets&#39; permission.
  * 
   * @param createAutomationStepRequest 
   * @return Int32ApiResponse
  */
  public Int32ApiResponse timesheetAutomationCreateAutomationStepPost (CreateAutomationStepRequest createAutomationStepRequest) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = createAutomationStepRequest;

    // create path and map variables
    String path = "/TimesheetAutomation/CreateAutomationStep";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    String[] contentTypes = {
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "x-chronosheets-auth" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (Int32ApiResponse) ApiInvoker.deserialize(localVarResponse, "", Int32ApiResponse.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Creates an automation step.  Timesheet automation is determined by looking at steps taken by the user.  Create a step to log some automation action, such as entering a geofence, scanning a QR Code or tapping on an NFC badge.  Requires the &#39;SubmitTimesheets&#39; permission.
   * 
   * @param createAutomationStepRequest 
  */
  public void timesheetAutomationCreateAutomationStepPost (CreateAutomationStepRequest createAutomationStepRequest, final Response.Listener<Int32ApiResponse> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = createAutomationStepRequest;


    // create path and map variables
    String path = "/TimesheetAutomation/CreateAutomationStep".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();



    String[] contentTypes = {
      "application/json"
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "x-chronosheets-auth" };

    try {
      apiInvoker.invokeAPI(basePath, path, "POST", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((Int32ApiResponse) ApiInvoker.deserialize(localVarResponse,  "", Int32ApiResponse.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Retrieve the timesheet automation / alerts for geofences activities  Requires the &#39;ManageGeofencing&#39; permission.
  * 
   * @param geofenceId The ID of the Geofence
   * @param userId The ID of the user
   * @param sort The field to sort the records by
   * @param order The directions to sort records by
   * @param skip Skip this many records
   * @param take Take this many records
   * @return TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated
  */
  public TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet (Integer geofenceId, Integer userId, AutomationAuditDataSortColumns sort, SortDirection order, Integer skip, Integer take) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;

    // create path and map variables
    String path = "/TimesheetAutomation/GetTimesheetAutomationGeofenceAuditTrail";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "GeofenceId", geofenceId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "UserId", userId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Order", order));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Skip", skip));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Take", take));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "x-chronosheets-auth" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated) ApiInvoker.deserialize(localVarResponse, "", TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Retrieve the timesheet automation / alerts for geofences activities  Requires the &#39;ManageGeofencing&#39; permission.
   * 
   * @param geofenceId The ID of the Geofence   * @param userId The ID of the user   * @param sort The field to sort the records by   * @param order The directions to sort records by   * @param skip Skip this many records   * @param take Take this many records
  */
  public void timesheetAutomationGetTimesheetAutomationGeofenceAuditTrailGet (Integer geofenceId, Integer userId, AutomationAuditDataSortColumns sort, SortDirection order, Integer skip, Integer take, final Response.Listener<TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;


    // create path and map variables
    String path = "/TimesheetAutomation/GetTimesheetAutomationGeofenceAuditTrail".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "GeofenceId", geofenceId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "UserId", userId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Order", order));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Skip", skip));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Take", take));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "x-chronosheets-auth" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated) ApiInvoker.deserialize(localVarResponse,  "", TimesheetAutomationWithOrgAndGeofenceListApiResponseForPaginated.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Retrieve the timesheet automation / alerts for NFC tag activities  Requires the &#39;ManageNFCCodes&#39; permission.
  * 
   * @param nfcTagId The ID of the NFC tag
   * @param userId The ID of the user
   * @param sort The field to sort the records by
   * @param order The directions to sort records by
   * @param skip Skip this many records
   * @param take Take this many records
   * @return TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated
  */
  public TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet (Integer nfcTagId, Integer userId, AutomationAuditDataSortColumns sort, SortDirection order, Integer skip, Integer take) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;

    // create path and map variables
    String path = "/TimesheetAutomation/GetTimesheetAutomationNFCTagAuditTrail";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "NfcTagId", nfcTagId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "UserId", userId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Order", order));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Skip", skip));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Take", take));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "x-chronosheets-auth" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated) ApiInvoker.deserialize(localVarResponse, "", TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Retrieve the timesheet automation / alerts for NFC tag activities  Requires the &#39;ManageNFCCodes&#39; permission.
   * 
   * @param nfcTagId The ID of the NFC tag   * @param userId The ID of the user   * @param sort The field to sort the records by   * @param order The directions to sort records by   * @param skip Skip this many records   * @param take Take this many records
  */
  public void timesheetAutomationGetTimesheetAutomationNFCTagAuditTrailGet (Integer nfcTagId, Integer userId, AutomationAuditDataSortColumns sort, SortDirection order, Integer skip, Integer take, final Response.Listener<TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;


    // create path and map variables
    String path = "/TimesheetAutomation/GetTimesheetAutomationNFCTagAuditTrail".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "NfcTagId", nfcTagId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "UserId", userId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Order", order));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Skip", skip));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Take", take));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "x-chronosheets-auth" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated) ApiInvoker.deserialize(localVarResponse,  "", TimesheetAutomationWithOrgAndNFCCodeListApiResponseForPaginated.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
  /**
  * Retrieve the timesheet automation / alerts for QR Code activities  Requires the &#39;ManageQRCodes&#39; permission.
  * 
   * @param qRCodeId The ID of the QR Code
   * @param userId The ID of the user
   * @param sort The field to sort the records by
   * @param order The directions to sort records by
   * @param skip Skip this many records
   * @param take Take this many records
   * @return TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated
  */
  public TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet (Integer qRCodeId, Integer userId, AutomationAuditDataSortColumns sort, SortDirection order, Integer skip, Integer take) throws TimeoutException, ExecutionException, InterruptedException, ApiException {
    Object postBody = null;

    // create path and map variables
    String path = "/TimesheetAutomation/GetTimesheetAutomationQRCodeAuditTrail";

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();
    queryParams.addAll(ApiInvoker.parameterToPairs("", "QRCodeId", qRCodeId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "UserId", userId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Order", order));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Skip", skip));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Take", take));
    String[] contentTypes = {
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
    }

    String[] authNames = new String[] { "x-chronosheets-auth" };

    try {
      String localVarResponse = apiInvoker.invokeAPI (basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames);
      if (localVarResponse != null) {
         return (TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated) ApiInvoker.deserialize(localVarResponse, "", TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated.class);
      } else {
         return null;
      }
    } catch (ApiException ex) {
       throw ex;
    } catch (InterruptedException ex) {
       throw ex;
    } catch (ExecutionException ex) {
      if (ex.getCause() instanceof VolleyError) {
        VolleyError volleyError = (VolleyError)ex.getCause();
        if (volleyError.networkResponse != null) {
          throw new ApiException(volleyError.networkResponse.statusCode, volleyError.getMessage());
        }
      }
      throw ex;
    } catch (TimeoutException ex) {
      throw ex;
    }
  }

      /**
   * Retrieve the timesheet automation / alerts for QR Code activities  Requires the &#39;ManageQRCodes&#39; permission.
   * 
   * @param qRCodeId The ID of the QR Code   * @param userId The ID of the user   * @param sort The field to sort the records by   * @param order The directions to sort records by   * @param skip Skip this many records   * @param take Take this many records
  */
  public void timesheetAutomationGetTimesheetAutomationQRCodeAuditTrailGet (Integer qRCodeId, Integer userId, AutomationAuditDataSortColumns sort, SortDirection order, Integer skip, Integer take, final Response.Listener<TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated> responseListener, final Response.ErrorListener errorListener) {
    Object postBody = null;


    // create path and map variables
    String path = "/TimesheetAutomation/GetTimesheetAutomationQRCodeAuditTrail".replaceAll("\\{format\\}","json");

    // query params
    List<Pair> queryParams = new ArrayList<Pair>();
    // header params
    Map<String, String> headerParams = new HashMap<String, String>();
    // form params
    Map<String, String> formParams = new HashMap<String, String>();

    queryParams.addAll(ApiInvoker.parameterToPairs("", "QRCodeId", qRCodeId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "UserId", userId));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Sort", sort));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Order", order));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Skip", skip));
    queryParams.addAll(ApiInvoker.parameterToPairs("", "Take", take));


    String[] contentTypes = {
      
    };
    String contentType = contentTypes.length > 0 ? contentTypes[0] : "application/json";

    if (contentType.startsWith("multipart/form-data")) {
      // file uploading
      MultipartEntityBuilder localVarBuilder = MultipartEntityBuilder.create();
      

      HttpEntity httpEntity = localVarBuilder.build();
      postBody = httpEntity;
    } else {
      // normal form params
          }

    String[] authNames = new String[] { "x-chronosheets-auth" };

    try {
      apiInvoker.invokeAPI(basePath, path, "GET", queryParams, postBody, headerParams, formParams, contentType, authNames,
        new Response.Listener<String>() {
          @Override
          public void onResponse(String localVarResponse) {
            try {
              responseListener.onResponse((TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated) ApiInvoker.deserialize(localVarResponse,  "", TimesheetAutomationWithOrgAndQRCodeListApiResponseForPaginated.class));
            } catch (ApiException exception) {
               errorListener.onErrorResponse(new VolleyError(exception));
            }
          }
      }, new Response.ErrorListener() {
          @Override
          public void onErrorResponse(VolleyError error) {
            errorListener.onErrorResponse(error);
          }
      });
    } catch (ApiException ex) {
      errorListener.onErrorResponse(new VolleyError(ex));
    }
  }
}
