/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import ChronoSheetsClientLibModel.TimesheetAutomationAction;
import java.util.Date;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * A request for triggering timesheet automation
 **/
@ApiModel(description = "A request for triggering timesheet automation")
public class CreateAutomationStepRequest {
  
  @SerializedName("GeofencingId")
  private Integer geofencingId = null;
  @SerializedName("NfcId")
  private Integer nfcId = null;
  @SerializedName("QRCodeId")
  private Integer qRCodeId = null;
  @SerializedName("AutomationActionType")
  private TimesheetAutomationAction automationActionType = null;
  @SerializedName("Latitude")
  private Double latitude = null;
  @SerializedName("Longitude")
  private Double longitude = null;
  @SerializedName("ClientTime")
  private Date clientTime = null;

  /**
   * The ID of the geofence being tracked. You must send only one of 'GeofencingId', 'NfcId' or 'QRCodeId'.
   **/
  @ApiModelProperty(value = "The ID of the geofence being tracked. You must send only one of 'GeofencingId', 'NfcId' or 'QRCodeId'.")
  public Integer getGeofencingId() {
    return geofencingId;
  }
  public void setGeofencingId(Integer geofencingId) {
    this.geofencingId = geofencingId;
  }

  /**
   * The ID of the NFC tag being tracked. You must send only one of 'GeofencingId', 'NfcId' or 'QRCodeId'.
   **/
  @ApiModelProperty(value = "The ID of the NFC tag being tracked. You must send only one of 'GeofencingId', 'NfcId' or 'QRCodeId'.")
  public Integer getNfcId() {
    return nfcId;
  }
  public void setNfcId(Integer nfcId) {
    this.nfcId = nfcId;
  }

  /**
   * The ID of the QR code being tracked. You must send only one of 'GeofencingId', 'NfcId' or 'QRCodeId'.
   **/
  @ApiModelProperty(value = "The ID of the QR code being tracked. You must send only one of 'GeofencingId', 'NfcId' or 'QRCodeId'.")
  public Integer getQRCodeId() {
    return qRCodeId;
  }
  public void setQRCodeId(Integer qRCodeId) {
    this.qRCodeId = qRCodeId;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public TimesheetAutomationAction getAutomationActionType() {
    return automationActionType;
  }
  public void setAutomationActionType(TimesheetAutomationAction automationActionType) {
    this.automationActionType = automationActionType;
  }

  /**
   * The latitude that this action is recorded at
   **/
  @ApiModelProperty(value = "The latitude that this action is recorded at")
  public Double getLatitude() {
    return latitude;
  }
  public void setLatitude(Double latitude) {
    this.latitude = latitude;
  }

  /**
   * The longitude that this action is recorded at
   **/
  @ApiModelProperty(value = "The longitude that this action is recorded at")
  public Double getLongitude() {
    return longitude;
  }
  public void setLongitude(Double longitude) {
    this.longitude = longitude;
  }

  /**
   * A timesheet of the user's current time when this action is requested
   **/
  @ApiModelProperty(value = "A timesheet of the user's current time when this action is requested")
  public Date getClientTime() {
    return clientTime;
  }
  public void setClientTime(Date clientTime) {
    this.clientTime = clientTime;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateAutomationStepRequest createAutomationStepRequest = (CreateAutomationStepRequest) o;
    return (this.geofencingId == null ? createAutomationStepRequest.geofencingId == null : this.geofencingId.equals(createAutomationStepRequest.geofencingId)) &&
        (this.nfcId == null ? createAutomationStepRequest.nfcId == null : this.nfcId.equals(createAutomationStepRequest.nfcId)) &&
        (this.qRCodeId == null ? createAutomationStepRequest.qRCodeId == null : this.qRCodeId.equals(createAutomationStepRequest.qRCodeId)) &&
        (this.automationActionType == null ? createAutomationStepRequest.automationActionType == null : this.automationActionType.equals(createAutomationStepRequest.automationActionType)) &&
        (this.latitude == null ? createAutomationStepRequest.latitude == null : this.latitude.equals(createAutomationStepRequest.latitude)) &&
        (this.longitude == null ? createAutomationStepRequest.longitude == null : this.longitude.equals(createAutomationStepRequest.longitude)) &&
        (this.clientTime == null ? createAutomationStepRequest.clientTime == null : this.clientTime.equals(createAutomationStepRequest.clientTime));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.geofencingId == null ? 0: this.geofencingId.hashCode());
    result = 31 * result + (this.nfcId == null ? 0: this.nfcId.hashCode());
    result = 31 * result + (this.qRCodeId == null ? 0: this.qRCodeId.hashCode());
    result = 31 * result + (this.automationActionType == null ? 0: this.automationActionType.hashCode());
    result = 31 * result + (this.latitude == null ? 0: this.latitude.hashCode());
    result = 31 * result + (this.longitude == null ? 0: this.longitude.hashCode());
    result = 31 * result + (this.clientTime == null ? 0: this.clientTime.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateAutomationStepRequest {\n");
    
    sb.append("  geofencingId: ").append(geofencingId).append("\n");
    sb.append("  nfcId: ").append(nfcId).append("\n");
    sb.append("  qRCodeId: ").append(qRCodeId).append("\n");
    sb.append("  automationActionType: ").append(automationActionType).append("\n");
    sb.append("  latitude: ").append(latitude).append("\n");
    sb.append("  longitude: ").append(longitude).append("\n");
    sb.append("  clientTime: ").append(clientTime).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
