/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import ChronoSheetsClientLibModel.TimesheetAutomationNFCCodeAlertSettings;
import ChronoSheetsClientLibModel.TimesheetAutomationNFCCodeTriggerSettings;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * A request object for creating a new NFC code
 **/
@ApiModel(description = "A request object for creating a new NFC code")
public class CreateNFCCodeRequest {
  
  @SerializedName("Name")
  private String name = null;
  @SerializedName("NFCTagData")
  private String nFCTagData = null;
  @SerializedName("TriggerJobCodeId")
  private Integer triggerJobCodeId = null;
  @SerializedName("TriggerTaskId")
  private Integer triggerTaskId = null;
  @SerializedName("SendAlertToOrgGroupId")
  private Integer sendAlertToOrgGroupId = null;
  @SerializedName("AlertSettings")
  private TimesheetAutomationNFCCodeAlertSettings alertSettings = null;
  @SerializedName("TriggerSettings")
  private TimesheetAutomationNFCCodeTriggerSettings triggerSettings = null;
  @SerializedName("StartTimeHour")
  private Integer startTimeHour = null;
  @SerializedName("StartTimeMinute")
  private Integer startTimeMinute = null;
  @SerializedName("EndTimeHour")
  private Integer endTimeHour = null;
  @SerializedName("EndTimeMinute")
  private Integer endTimeMinute = null;

  /**
   * The name of the NFC code
   **/
  @ApiModelProperty(value = "The name of the NFC code")
  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  /**
   * The data stored on the NFC tag used to identify it
   **/
  @ApiModelProperty(value = "The data stored on the NFC tag used to identify it")
  public String getNFCTagData() {
    return nFCTagData;
  }
  public void setNFCTagData(String nFCTagData) {
    this.nFCTagData = nFCTagData;
  }

  /**
   * The job code to be used when the person activates/deactivates the NFC code
   **/
  @ApiModelProperty(value = "The job code to be used when the person activates/deactivates the NFC code")
  public Integer getTriggerJobCodeId() {
    return triggerJobCodeId;
  }
  public void setTriggerJobCodeId(Integer triggerJobCodeId) {
    this.triggerJobCodeId = triggerJobCodeId;
  }

  /**
   * The task to be used when the person activates/deactivates the NFC code
   **/
  @ApiModelProperty(value = "The task to be used when the person activates/deactivates the NFC code")
  public Integer getTriggerTaskId() {
    return triggerTaskId;
  }
  public void setTriggerTaskId(Integer triggerTaskId) {
    this.triggerTaskId = triggerTaskId;
  }

  /**
   * Send an alert to a user, specified by their user ID
   **/
  @ApiModelProperty(value = "Send an alert to a user, specified by their user ID")
  public Integer getSendAlertToOrgGroupId() {
    return sendAlertToOrgGroupId;
  }
  public void setSendAlertToOrgGroupId(Integer sendAlertToOrgGroupId) {
    this.sendAlertToOrgGroupId = sendAlertToOrgGroupId;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public TimesheetAutomationNFCCodeAlertSettings getAlertSettings() {
    return alertSettings;
  }
  public void setAlertSettings(TimesheetAutomationNFCCodeAlertSettings alertSettings) {
    this.alertSettings = alertSettings;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public TimesheetAutomationNFCCodeTriggerSettings getTriggerSettings() {
    return triggerSettings;
  }
  public void setTriggerSettings(TimesheetAutomationNFCCodeTriggerSettings triggerSettings) {
    this.triggerSettings = triggerSettings;
  }

  /**
   * The start hour in which this NFC code should apply.  After this time, the NFC code will be active.
   **/
  @ApiModelProperty(value = "The start hour in which this NFC code should apply.  After this time, the NFC code will be active.")
  public Integer getStartTimeHour() {
    return startTimeHour;
  }
  public void setStartTimeHour(Integer startTimeHour) {
    this.startTimeHour = startTimeHour;
  }

  /**
   * The start minute in which this NFC code should apply.  After this time, the NFC code will be active.
   **/
  @ApiModelProperty(value = "The start minute in which this NFC code should apply.  After this time, the NFC code will be active.")
  public Integer getStartTimeMinute() {
    return startTimeMinute;
  }
  public void setStartTimeMinute(Integer startTimeMinute) {
    this.startTimeMinute = startTimeMinute;
  }

  /**
   * The end hour in which this NFC code will stop applying.  After this time, the NFC code will be inactive.
   **/
  @ApiModelProperty(value = "The end hour in which this NFC code will stop applying.  After this time, the NFC code will be inactive.")
  public Integer getEndTimeHour() {
    return endTimeHour;
  }
  public void setEndTimeHour(Integer endTimeHour) {
    this.endTimeHour = endTimeHour;
  }

  /**
   * The end minute in which this NFC code will stop applying.  After this time, the NFC code will be inactive.
   **/
  @ApiModelProperty(value = "The end minute in which this NFC code will stop applying.  After this time, the NFC code will be inactive.")
  public Integer getEndTimeMinute() {
    return endTimeMinute;
  }
  public void setEndTimeMinute(Integer endTimeMinute) {
    this.endTimeMinute = endTimeMinute;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    CreateNFCCodeRequest createNFCCodeRequest = (CreateNFCCodeRequest) o;
    return (this.name == null ? createNFCCodeRequest.name == null : this.name.equals(createNFCCodeRequest.name)) &&
        (this.nFCTagData == null ? createNFCCodeRequest.nFCTagData == null : this.nFCTagData.equals(createNFCCodeRequest.nFCTagData)) &&
        (this.triggerJobCodeId == null ? createNFCCodeRequest.triggerJobCodeId == null : this.triggerJobCodeId.equals(createNFCCodeRequest.triggerJobCodeId)) &&
        (this.triggerTaskId == null ? createNFCCodeRequest.triggerTaskId == null : this.triggerTaskId.equals(createNFCCodeRequest.triggerTaskId)) &&
        (this.sendAlertToOrgGroupId == null ? createNFCCodeRequest.sendAlertToOrgGroupId == null : this.sendAlertToOrgGroupId.equals(createNFCCodeRequest.sendAlertToOrgGroupId)) &&
        (this.alertSettings == null ? createNFCCodeRequest.alertSettings == null : this.alertSettings.equals(createNFCCodeRequest.alertSettings)) &&
        (this.triggerSettings == null ? createNFCCodeRequest.triggerSettings == null : this.triggerSettings.equals(createNFCCodeRequest.triggerSettings)) &&
        (this.startTimeHour == null ? createNFCCodeRequest.startTimeHour == null : this.startTimeHour.equals(createNFCCodeRequest.startTimeHour)) &&
        (this.startTimeMinute == null ? createNFCCodeRequest.startTimeMinute == null : this.startTimeMinute.equals(createNFCCodeRequest.startTimeMinute)) &&
        (this.endTimeHour == null ? createNFCCodeRequest.endTimeHour == null : this.endTimeHour.equals(createNFCCodeRequest.endTimeHour)) &&
        (this.endTimeMinute == null ? createNFCCodeRequest.endTimeMinute == null : this.endTimeMinute.equals(createNFCCodeRequest.endTimeMinute));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.name == null ? 0: this.name.hashCode());
    result = 31 * result + (this.nFCTagData == null ? 0: this.nFCTagData.hashCode());
    result = 31 * result + (this.triggerJobCodeId == null ? 0: this.triggerJobCodeId.hashCode());
    result = 31 * result + (this.triggerTaskId == null ? 0: this.triggerTaskId.hashCode());
    result = 31 * result + (this.sendAlertToOrgGroupId == null ? 0: this.sendAlertToOrgGroupId.hashCode());
    result = 31 * result + (this.alertSettings == null ? 0: this.alertSettings.hashCode());
    result = 31 * result + (this.triggerSettings == null ? 0: this.triggerSettings.hashCode());
    result = 31 * result + (this.startTimeHour == null ? 0: this.startTimeHour.hashCode());
    result = 31 * result + (this.startTimeMinute == null ? 0: this.startTimeMinute.hashCode());
    result = 31 * result + (this.endTimeHour == null ? 0: this.endTimeHour.hashCode());
    result = 31 * result + (this.endTimeMinute == null ? 0: this.endTimeMinute.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class CreateNFCCodeRequest {\n");
    
    sb.append("  name: ").append(name).append("\n");
    sb.append("  nFCTagData: ").append(nFCTagData).append("\n");
    sb.append("  triggerJobCodeId: ").append(triggerJobCodeId).append("\n");
    sb.append("  triggerTaskId: ").append(triggerTaskId).append("\n");
    sb.append("  sendAlertToOrgGroupId: ").append(sendAlertToOrgGroupId).append("\n");
    sb.append("  alertSettings: ").append(alertSettings).append("\n");
    sb.append("  triggerSettings: ").append(triggerSettings).append("\n");
    sb.append("  startTimeHour: ").append(startTimeHour).append("\n");
    sb.append("  startTimeMinute: ").append(startTimeMinute).append("\n");
    sb.append("  endTimeHour: ").append(endTimeHour).append("\n");
    sb.append("  endTimeMinute: ").append(endTimeMinute).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
