/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import ChronoSheetsClientLibModel.TimesheetAutomationQRCodeAlertSettings;
import ChronoSheetsClientLibModel.TimesheetAutomationQRCodeTriggerSettings;
import java.util.Date;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * An extended QR Code record
 **/
@ApiModel(description = "An extended QR Code record")
public class ExtendedQRCode {
  
  @SerializedName("QRCodeId")
  private Integer qRCodeId = null;
  @SerializedName("OrgId")
  private Integer orgId = null;
  @SerializedName("CreatedByUserId")
  private Integer createdByUserId = null;
  @SerializedName("LastUpdatedByUserId")
  private Integer lastUpdatedByUserId = null;
  @SerializedName("Name")
  private String name = null;
  @SerializedName("CreatedAt")
  private Date createdAt = null;
  @SerializedName("UpdatedAt")
  private Date updatedAt = null;
  @SerializedName("TriggerJobCodeId")
  private Integer triggerJobCodeId = null;
  @SerializedName("TriggerTaskId")
  private Integer triggerTaskId = null;
  @SerializedName("TriggerSettings")
  private TimesheetAutomationQRCodeTriggerSettings triggerSettings = null;
  @SerializedName("AlertToOrgGroupId")
  private Integer alertToOrgGroupId = null;
  @SerializedName("AlertSettings")
  private TimesheetAutomationQRCodeAlertSettings alertSettings = null;
  @SerializedName("StartTimeHour")
  private Integer startTimeHour = null;
  @SerializedName("StartTimeMinute")
  private Integer startTimeMinute = null;
  @SerializedName("EndTimeHour")
  private Integer endTimeHour = null;
  @SerializedName("EndTimeMinute")
  private Integer endTimeMinute = null;
  @SerializedName("JobCode")
  private String jobCode = null;
  @SerializedName("TaskName")
  private String taskName = null;
  @SerializedName("CreatedBy")
  private String createdBy = null;
  @SerializedName("UpdatedBy")
  private String updatedBy = null;
  @SerializedName("AlertOrganisation")
  private String alertOrganisation = null;

  /**
   * The ID of the QR code
   **/
  @ApiModelProperty(value = "The ID of the QR code")
  public Integer getQRCodeId() {
    return qRCodeId;
  }
  public void setQRCodeId(Integer qRCodeId) {
    this.qRCodeId = qRCodeId;
  }

  /**
   * The ID of the organisation owning the QR code record
   **/
  @ApiModelProperty(value = "The ID of the organisation owning the QR code record")
  public Integer getOrgId() {
    return orgId;
  }
  public void setOrgId(Integer orgId) {
    this.orgId = orgId;
  }

  /**
   * The ID of the user/employee who created the QR code
   **/
  @ApiModelProperty(value = "The ID of the user/employee who created the QR code")
  public Integer getCreatedByUserId() {
    return createdByUserId;
  }
  public void setCreatedByUserId(Integer createdByUserId) {
    this.createdByUserId = createdByUserId;
  }

  /**
   * The ID of the user/employee who last updated the QR code
   **/
  @ApiModelProperty(value = "The ID of the user/employee who last updated the QR code")
  public Integer getLastUpdatedByUserId() {
    return lastUpdatedByUserId;
  }
  public void setLastUpdatedByUserId(Integer lastUpdatedByUserId) {
    this.lastUpdatedByUserId = lastUpdatedByUserId;
  }

  /**
   * A descriptive name of the QR code
   **/
  @ApiModelProperty(value = "A descriptive name of the QR code")
  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  /**
   * The date and time the QR code was created.  Time is in UTC.
   **/
  @ApiModelProperty(value = "The date and time the QR code was created.  Time is in UTC.")
  public Date getCreatedAt() {
    return createdAt;
  }
  public void setCreatedAt(Date createdAt) {
    this.createdAt = createdAt;
  }

  /**
   * The date and time the QR code was updated last.  Time is in UTC.
   **/
  @ApiModelProperty(value = "The date and time the QR code was updated last.  Time is in UTC.")
  public Date getUpdatedAt() {
    return updatedAt;
  }
  public void setUpdatedAt(Date updatedAt) {
    this.updatedAt = updatedAt;
  }

  /**
   * The ID of the job code used when the employee activates/deactivates the QR code
   **/
  @ApiModelProperty(value = "The ID of the job code used when the employee activates/deactivates the QR code")
  public Integer getTriggerJobCodeId() {
    return triggerJobCodeId;
  }
  public void setTriggerJobCodeId(Integer triggerJobCodeId) {
    this.triggerJobCodeId = triggerJobCodeId;
  }

  /**
   * The ID of the task used when the employee activates/deactivates the QR code
   **/
  @ApiModelProperty(value = "The ID of the task used when the employee activates/deactivates the QR code")
  public Integer getTriggerTaskId() {
    return triggerTaskId;
  }
  public void setTriggerTaskId(Integer triggerTaskId) {
    this.triggerTaskId = triggerTaskId;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public TimesheetAutomationQRCodeTriggerSettings getTriggerSettings() {
    return triggerSettings;
  }
  public void setTriggerSettings(TimesheetAutomationQRCodeTriggerSettings triggerSettings) {
    this.triggerSettings = triggerSettings;
  }

  /**
   * The organisation group that will be notified when the QR code is triggered
   **/
  @ApiModelProperty(value = "The organisation group that will be notified when the QR code is triggered")
  public Integer getAlertToOrgGroupId() {
    return alertToOrgGroupId;
  }
  public void setAlertToOrgGroupId(Integer alertToOrgGroupId) {
    this.alertToOrgGroupId = alertToOrgGroupId;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public TimesheetAutomationQRCodeAlertSettings getAlertSettings() {
    return alertSettings;
  }
  public void setAlertSettings(TimesheetAutomationQRCodeAlertSettings alertSettings) {
    this.alertSettings = alertSettings;
  }

  /**
   * The hour start time. E.g. 13 would be 1pm.  Time is in 24hr format.
   **/
  @ApiModelProperty(value = "The hour start time. E.g. 13 would be 1pm.  Time is in 24hr format.")
  public Integer getStartTimeHour() {
    return startTimeHour;
  }
  public void setStartTimeHour(Integer startTimeHour) {
    this.startTimeHour = startTimeHour;
  }

  /**
   * The minute start time.  E.g. 46 would be the 46th minute of the hour.
   **/
  @ApiModelProperty(value = "The minute start time.  E.g. 46 would be the 46th minute of the hour.")
  public Integer getStartTimeMinute() {
    return startTimeMinute;
  }
  public void setStartTimeMinute(Integer startTimeMinute) {
    this.startTimeMinute = startTimeMinute;
  }

  /**
   * The hour end time. E.g. 21 would be 9pm.  Time is in 24hr format.
   **/
  @ApiModelProperty(value = "The hour end time. E.g. 21 would be 9pm.  Time is in 24hr format.")
  public Integer getEndTimeHour() {
    return endTimeHour;
  }
  public void setEndTimeHour(Integer endTimeHour) {
    this.endTimeHour = endTimeHour;
  }

  /**
   * The minute end time.  E.g. 13 would be the 13th minute of the hour.
   **/
  @ApiModelProperty(value = "The minute end time.  E.g. 13 would be the 13th minute of the hour.")
  public Integer getEndTimeMinute() {
    return endTimeMinute;
  }
  public void setEndTimeMinute(Integer endTimeMinute) {
    this.endTimeMinute = endTimeMinute;
  }

  /**
   * The Job code used when the employee activates/deactivates the QR code
   **/
  @ApiModelProperty(value = "The Job code used when the employee activates/deactivates the QR code")
  public String getJobCode() {
    return jobCode;
  }
  public void setJobCode(String jobCode) {
    this.jobCode = jobCode;
  }

  /**
   * The name of the task used when the employee activates/deactivates the QR code
   **/
  @ApiModelProperty(value = "The name of the task used when the employee activates/deactivates the QR code")
  public String getTaskName() {
    return taskName;
  }
  public void setTaskName(String taskName) {
    this.taskName = taskName;
  }

  /**
   * The name of the employee who created the QR code
   **/
  @ApiModelProperty(value = "The name of the employee who created the QR code")
  public String getCreatedBy() {
    return createdBy;
  }
  public void setCreatedBy(String createdBy) {
    this.createdBy = createdBy;
  }

  /**
   * The name of the employee who last updated the QR code
   **/
  @ApiModelProperty(value = "The name of the employee who last updated the QR code")
  public String getUpdatedBy() {
    return updatedBy;
  }
  public void setUpdatedBy(String updatedBy) {
    this.updatedBy = updatedBy;
  }

  /**
   * The name of the organisation group who will be notified when the QR code is triggered
   **/
  @ApiModelProperty(value = "The name of the organisation group who will be notified when the QR code is triggered")
  public String getAlertOrganisation() {
    return alertOrganisation;
  }
  public void setAlertOrganisation(String alertOrganisation) {
    this.alertOrganisation = alertOrganisation;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    ExtendedQRCode extendedQRCode = (ExtendedQRCode) o;
    return (this.qRCodeId == null ? extendedQRCode.qRCodeId == null : this.qRCodeId.equals(extendedQRCode.qRCodeId)) &&
        (this.orgId == null ? extendedQRCode.orgId == null : this.orgId.equals(extendedQRCode.orgId)) &&
        (this.createdByUserId == null ? extendedQRCode.createdByUserId == null : this.createdByUserId.equals(extendedQRCode.createdByUserId)) &&
        (this.lastUpdatedByUserId == null ? extendedQRCode.lastUpdatedByUserId == null : this.lastUpdatedByUserId.equals(extendedQRCode.lastUpdatedByUserId)) &&
        (this.name == null ? extendedQRCode.name == null : this.name.equals(extendedQRCode.name)) &&
        (this.createdAt == null ? extendedQRCode.createdAt == null : this.createdAt.equals(extendedQRCode.createdAt)) &&
        (this.updatedAt == null ? extendedQRCode.updatedAt == null : this.updatedAt.equals(extendedQRCode.updatedAt)) &&
        (this.triggerJobCodeId == null ? extendedQRCode.triggerJobCodeId == null : this.triggerJobCodeId.equals(extendedQRCode.triggerJobCodeId)) &&
        (this.triggerTaskId == null ? extendedQRCode.triggerTaskId == null : this.triggerTaskId.equals(extendedQRCode.triggerTaskId)) &&
        (this.triggerSettings == null ? extendedQRCode.triggerSettings == null : this.triggerSettings.equals(extendedQRCode.triggerSettings)) &&
        (this.alertToOrgGroupId == null ? extendedQRCode.alertToOrgGroupId == null : this.alertToOrgGroupId.equals(extendedQRCode.alertToOrgGroupId)) &&
        (this.alertSettings == null ? extendedQRCode.alertSettings == null : this.alertSettings.equals(extendedQRCode.alertSettings)) &&
        (this.startTimeHour == null ? extendedQRCode.startTimeHour == null : this.startTimeHour.equals(extendedQRCode.startTimeHour)) &&
        (this.startTimeMinute == null ? extendedQRCode.startTimeMinute == null : this.startTimeMinute.equals(extendedQRCode.startTimeMinute)) &&
        (this.endTimeHour == null ? extendedQRCode.endTimeHour == null : this.endTimeHour.equals(extendedQRCode.endTimeHour)) &&
        (this.endTimeMinute == null ? extendedQRCode.endTimeMinute == null : this.endTimeMinute.equals(extendedQRCode.endTimeMinute)) &&
        (this.jobCode == null ? extendedQRCode.jobCode == null : this.jobCode.equals(extendedQRCode.jobCode)) &&
        (this.taskName == null ? extendedQRCode.taskName == null : this.taskName.equals(extendedQRCode.taskName)) &&
        (this.createdBy == null ? extendedQRCode.createdBy == null : this.createdBy.equals(extendedQRCode.createdBy)) &&
        (this.updatedBy == null ? extendedQRCode.updatedBy == null : this.updatedBy.equals(extendedQRCode.updatedBy)) &&
        (this.alertOrganisation == null ? extendedQRCode.alertOrganisation == null : this.alertOrganisation.equals(extendedQRCode.alertOrganisation));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.qRCodeId == null ? 0: this.qRCodeId.hashCode());
    result = 31 * result + (this.orgId == null ? 0: this.orgId.hashCode());
    result = 31 * result + (this.createdByUserId == null ? 0: this.createdByUserId.hashCode());
    result = 31 * result + (this.lastUpdatedByUserId == null ? 0: this.lastUpdatedByUserId.hashCode());
    result = 31 * result + (this.name == null ? 0: this.name.hashCode());
    result = 31 * result + (this.createdAt == null ? 0: this.createdAt.hashCode());
    result = 31 * result + (this.updatedAt == null ? 0: this.updatedAt.hashCode());
    result = 31 * result + (this.triggerJobCodeId == null ? 0: this.triggerJobCodeId.hashCode());
    result = 31 * result + (this.triggerTaskId == null ? 0: this.triggerTaskId.hashCode());
    result = 31 * result + (this.triggerSettings == null ? 0: this.triggerSettings.hashCode());
    result = 31 * result + (this.alertToOrgGroupId == null ? 0: this.alertToOrgGroupId.hashCode());
    result = 31 * result + (this.alertSettings == null ? 0: this.alertSettings.hashCode());
    result = 31 * result + (this.startTimeHour == null ? 0: this.startTimeHour.hashCode());
    result = 31 * result + (this.startTimeMinute == null ? 0: this.startTimeMinute.hashCode());
    result = 31 * result + (this.endTimeHour == null ? 0: this.endTimeHour.hashCode());
    result = 31 * result + (this.endTimeMinute == null ? 0: this.endTimeMinute.hashCode());
    result = 31 * result + (this.jobCode == null ? 0: this.jobCode.hashCode());
    result = 31 * result + (this.taskName == null ? 0: this.taskName.hashCode());
    result = 31 * result + (this.createdBy == null ? 0: this.createdBy.hashCode());
    result = 31 * result + (this.updatedBy == null ? 0: this.updatedBy.hashCode());
    result = 31 * result + (this.alertOrganisation == null ? 0: this.alertOrganisation.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class ExtendedQRCode {\n");
    
    sb.append("  qRCodeId: ").append(qRCodeId).append("\n");
    sb.append("  orgId: ").append(orgId).append("\n");
    sb.append("  createdByUserId: ").append(createdByUserId).append("\n");
    sb.append("  lastUpdatedByUserId: ").append(lastUpdatedByUserId).append("\n");
    sb.append("  name: ").append(name).append("\n");
    sb.append("  createdAt: ").append(createdAt).append("\n");
    sb.append("  updatedAt: ").append(updatedAt).append("\n");
    sb.append("  triggerJobCodeId: ").append(triggerJobCodeId).append("\n");
    sb.append("  triggerTaskId: ").append(triggerTaskId).append("\n");
    sb.append("  triggerSettings: ").append(triggerSettings).append("\n");
    sb.append("  alertToOrgGroupId: ").append(alertToOrgGroupId).append("\n");
    sb.append("  alertSettings: ").append(alertSettings).append("\n");
    sb.append("  startTimeHour: ").append(startTimeHour).append("\n");
    sb.append("  startTimeMinute: ").append(startTimeMinute).append("\n");
    sb.append("  endTimeHour: ").append(endTimeHour).append("\n");
    sb.append("  endTimeMinute: ").append(endTimeMinute).append("\n");
    sb.append("  jobCode: ").append(jobCode).append("\n");
    sb.append("  taskName: ").append(taskName).append("\n");
    sb.append("  createdBy: ").append(createdBy).append("\n");
    sb.append("  updatedBy: ").append(updatedBy).append("\n");
    sb.append("  alertOrganisation: ").append(alertOrganisation).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
