/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import java.util.*;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class FleetSummaryReportItem {
  
  @SerializedName("Id")
  private Integer id = null;
  @SerializedName("OrganisationId")
  private Integer organisationId = null;
  @SerializedName("Name")
  private String name = null;
  @SerializedName("CostPerKilometer")
  private Double costPerKilometer = null;
  @SerializedName("Make")
  private String make = null;
  @SerializedName("Model")
  private String model = null;
  @SerializedName("Year")
  private String year = null;
  @SerializedName("LicencePlateNumber")
  private String licencePlateNumber = null;
  @SerializedName("IsDeleted")
  private Boolean isDeleted = null;
  @SerializedName("PermittedEmployees")
  private List<Integer> permittedEmployees = null;
  @SerializedName("TotalDistanceMetersFiltered")
  private Double totalDistanceMetersFiltered = null;
  @SerializedName("TotalDistanceMeters")
  private Double totalDistanceMeters = null;
  @SerializedName("TotalRunningCostDollarsFiltered")
  private Double totalRunningCostDollarsFiltered = null;
  @SerializedName("TotalRunningCostDollars")
  private Double totalRunningCostDollars = null;

  /**
   * The ID of the vehicle
   **/
  @ApiModelProperty(value = "The ID of the vehicle")
  public Integer getId() {
    return id;
  }
  public void setId(Integer id) {
    this.id = id;
  }

  /**
   * The ID of the organisation managing the vehicle
   **/
  @ApiModelProperty(value = "The ID of the organisation managing the vehicle")
  public Integer getOrganisationId() {
    return organisationId;
  }
  public void setOrganisationId(Integer organisationId) {
    this.organisationId = organisationId;
  }

  /**
   * A name given to the vehicle
   **/
  @ApiModelProperty(value = "A name given to the vehicle")
  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  /**
   * The cost, in dollars, of running the vehicle over one kilometer
   **/
  @ApiModelProperty(value = "The cost, in dollars, of running the vehicle over one kilometer")
  public Double getCostPerKilometer() {
    return costPerKilometer;
  }
  public void setCostPerKilometer(Double costPerKilometer) {
    this.costPerKilometer = costPerKilometer;
  }

  /**
   * The make of the vehicle
   **/
  @ApiModelProperty(value = "The make of the vehicle")
  public String getMake() {
    return make;
  }
  public void setMake(String make) {
    this.make = make;
  }

  /**
   * The model of the vehicle
   **/
  @ApiModelProperty(value = "The model of the vehicle")
  public String getModel() {
    return model;
  }
  public void setModel(String model) {
    this.model = model;
  }

  /**
   * The year the vehicle was manufactured
   **/
  @ApiModelProperty(value = "The year the vehicle was manufactured")
  public String getYear() {
    return year;
  }
  public void setYear(String year) {
    this.year = year;
  }

  /**
   * The licence plate number of the vehicle
   **/
  @ApiModelProperty(value = "The licence plate number of the vehicle")
  public String getLicencePlateNumber() {
    return licencePlateNumber;
  }
  public void setLicencePlateNumber(String licencePlateNumber) {
    this.licencePlateNumber = licencePlateNumber;
  }

  /**
   * Whether or not the vehicle is deleted
   **/
  @ApiModelProperty(value = "Whether or not the vehicle is deleted")
  public Boolean getIsDeleted() {
    return isDeleted;
  }
  public void setIsDeleted(Boolean isDeleted) {
    this.isDeleted = isDeleted;
  }

  /**
   * An array of employee IDs that are permitted to use the vehicle
   **/
  @ApiModelProperty(value = "An array of employee IDs that are permitted to use the vehicle")
  public List<Integer> getPermittedEmployees() {
    return permittedEmployees;
  }
  public void setPermittedEmployees(List<Integer> permittedEmployees) {
    this.permittedEmployees = permittedEmployees;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public Double getTotalDistanceMetersFiltered() {
    return totalDistanceMetersFiltered;
  }
  public void setTotalDistanceMetersFiltered(Double totalDistanceMetersFiltered) {
    this.totalDistanceMetersFiltered = totalDistanceMetersFiltered;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public Double getTotalDistanceMeters() {
    return totalDistanceMeters;
  }
  public void setTotalDistanceMeters(Double totalDistanceMeters) {
    this.totalDistanceMeters = totalDistanceMeters;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public Double getTotalRunningCostDollarsFiltered() {
    return totalRunningCostDollarsFiltered;
  }
  public void setTotalRunningCostDollarsFiltered(Double totalRunningCostDollarsFiltered) {
    this.totalRunningCostDollarsFiltered = totalRunningCostDollarsFiltered;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public Double getTotalRunningCostDollars() {
    return totalRunningCostDollars;
  }
  public void setTotalRunningCostDollars(Double totalRunningCostDollars) {
    this.totalRunningCostDollars = totalRunningCostDollars;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FleetSummaryReportItem fleetSummaryReportItem = (FleetSummaryReportItem) o;
    return (this.id == null ? fleetSummaryReportItem.id == null : this.id.equals(fleetSummaryReportItem.id)) &&
        (this.organisationId == null ? fleetSummaryReportItem.organisationId == null : this.organisationId.equals(fleetSummaryReportItem.organisationId)) &&
        (this.name == null ? fleetSummaryReportItem.name == null : this.name.equals(fleetSummaryReportItem.name)) &&
        (this.costPerKilometer == null ? fleetSummaryReportItem.costPerKilometer == null : this.costPerKilometer.equals(fleetSummaryReportItem.costPerKilometer)) &&
        (this.make == null ? fleetSummaryReportItem.make == null : this.make.equals(fleetSummaryReportItem.make)) &&
        (this.model == null ? fleetSummaryReportItem.model == null : this.model.equals(fleetSummaryReportItem.model)) &&
        (this.year == null ? fleetSummaryReportItem.year == null : this.year.equals(fleetSummaryReportItem.year)) &&
        (this.licencePlateNumber == null ? fleetSummaryReportItem.licencePlateNumber == null : this.licencePlateNumber.equals(fleetSummaryReportItem.licencePlateNumber)) &&
        (this.isDeleted == null ? fleetSummaryReportItem.isDeleted == null : this.isDeleted.equals(fleetSummaryReportItem.isDeleted)) &&
        (this.permittedEmployees == null ? fleetSummaryReportItem.permittedEmployees == null : this.permittedEmployees.equals(fleetSummaryReportItem.permittedEmployees)) &&
        (this.totalDistanceMetersFiltered == null ? fleetSummaryReportItem.totalDistanceMetersFiltered == null : this.totalDistanceMetersFiltered.equals(fleetSummaryReportItem.totalDistanceMetersFiltered)) &&
        (this.totalDistanceMeters == null ? fleetSummaryReportItem.totalDistanceMeters == null : this.totalDistanceMeters.equals(fleetSummaryReportItem.totalDistanceMeters)) &&
        (this.totalRunningCostDollarsFiltered == null ? fleetSummaryReportItem.totalRunningCostDollarsFiltered == null : this.totalRunningCostDollarsFiltered.equals(fleetSummaryReportItem.totalRunningCostDollarsFiltered)) &&
        (this.totalRunningCostDollars == null ? fleetSummaryReportItem.totalRunningCostDollars == null : this.totalRunningCostDollars.equals(fleetSummaryReportItem.totalRunningCostDollars));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.id == null ? 0: this.id.hashCode());
    result = 31 * result + (this.organisationId == null ? 0: this.organisationId.hashCode());
    result = 31 * result + (this.name == null ? 0: this.name.hashCode());
    result = 31 * result + (this.costPerKilometer == null ? 0: this.costPerKilometer.hashCode());
    result = 31 * result + (this.make == null ? 0: this.make.hashCode());
    result = 31 * result + (this.model == null ? 0: this.model.hashCode());
    result = 31 * result + (this.year == null ? 0: this.year.hashCode());
    result = 31 * result + (this.licencePlateNumber == null ? 0: this.licencePlateNumber.hashCode());
    result = 31 * result + (this.isDeleted == null ? 0: this.isDeleted.hashCode());
    result = 31 * result + (this.permittedEmployees == null ? 0: this.permittedEmployees.hashCode());
    result = 31 * result + (this.totalDistanceMetersFiltered == null ? 0: this.totalDistanceMetersFiltered.hashCode());
    result = 31 * result + (this.totalDistanceMeters == null ? 0: this.totalDistanceMeters.hashCode());
    result = 31 * result + (this.totalRunningCostDollarsFiltered == null ? 0: this.totalRunningCostDollarsFiltered.hashCode());
    result = 31 * result + (this.totalRunningCostDollars == null ? 0: this.totalRunningCostDollars.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class FleetSummaryReportItem {\n");
    
    sb.append("  id: ").append(id).append("\n");
    sb.append("  organisationId: ").append(organisationId).append("\n");
    sb.append("  name: ").append(name).append("\n");
    sb.append("  costPerKilometer: ").append(costPerKilometer).append("\n");
    sb.append("  make: ").append(make).append("\n");
    sb.append("  model: ").append(model).append("\n");
    sb.append("  year: ").append(year).append("\n");
    sb.append("  licencePlateNumber: ").append(licencePlateNumber).append("\n");
    sb.append("  isDeleted: ").append(isDeleted).append("\n");
    sb.append("  permittedEmployees: ").append(permittedEmployees).append("\n");
    sb.append("  totalDistanceMetersFiltered: ").append(totalDistanceMetersFiltered).append("\n");
    sb.append("  totalDistanceMeters: ").append(totalDistanceMeters).append("\n");
    sb.append("  totalRunningCostDollarsFiltered: ").append(totalRunningCostDollarsFiltered).append("\n");
    sb.append("  totalRunningCostDollars: ").append(totalRunningCostDollars).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
