/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import java.util.*;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * A vehicle within the fleet
 **/
@ApiModel(description = "A vehicle within the fleet")
public class FleetVehicle {
  
  @SerializedName("Id")
  private Integer id = null;
  @SerializedName("OrganisationId")
  private Integer organisationId = null;
  @SerializedName("Name")
  private String name = null;
  @SerializedName("CostPerKilometer")
  private Double costPerKilometer = null;
  @SerializedName("Make")
  private String make = null;
  @SerializedName("Model")
  private String model = null;
  @SerializedName("Year")
  private String year = null;
  @SerializedName("LicencePlateNumber")
  private String licencePlateNumber = null;
  @SerializedName("IsDeleted")
  private Boolean isDeleted = null;
  @SerializedName("PermittedEmployees")
  private List<Integer> permittedEmployees = null;

  /**
   * The ID of the vehicle
   **/
  @ApiModelProperty(value = "The ID of the vehicle")
  public Integer getId() {
    return id;
  }
  public void setId(Integer id) {
    this.id = id;
  }

  /**
   * The ID of the organisation managing the vehicle
   **/
  @ApiModelProperty(value = "The ID of the organisation managing the vehicle")
  public Integer getOrganisationId() {
    return organisationId;
  }
  public void setOrganisationId(Integer organisationId) {
    this.organisationId = organisationId;
  }

  /**
   * A name given to the vehicle
   **/
  @ApiModelProperty(value = "A name given to the vehicle")
  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  /**
   * The cost, in dollars, of running the vehicle over one kilometer
   **/
  @ApiModelProperty(value = "The cost, in dollars, of running the vehicle over one kilometer")
  public Double getCostPerKilometer() {
    return costPerKilometer;
  }
  public void setCostPerKilometer(Double costPerKilometer) {
    this.costPerKilometer = costPerKilometer;
  }

  /**
   * The make of the vehicle
   **/
  @ApiModelProperty(value = "The make of the vehicle")
  public String getMake() {
    return make;
  }
  public void setMake(String make) {
    this.make = make;
  }

  /**
   * The model of the vehicle
   **/
  @ApiModelProperty(value = "The model of the vehicle")
  public String getModel() {
    return model;
  }
  public void setModel(String model) {
    this.model = model;
  }

  /**
   * The year the vehicle was manufactured
   **/
  @ApiModelProperty(value = "The year the vehicle was manufactured")
  public String getYear() {
    return year;
  }
  public void setYear(String year) {
    this.year = year;
  }

  /**
   * The licence plate number of the vehicle
   **/
  @ApiModelProperty(value = "The licence plate number of the vehicle")
  public String getLicencePlateNumber() {
    return licencePlateNumber;
  }
  public void setLicencePlateNumber(String licencePlateNumber) {
    this.licencePlateNumber = licencePlateNumber;
  }

  /**
   * Whether or not the vehicle is deleted
   **/
  @ApiModelProperty(value = "Whether or not the vehicle is deleted")
  public Boolean getIsDeleted() {
    return isDeleted;
  }
  public void setIsDeleted(Boolean isDeleted) {
    this.isDeleted = isDeleted;
  }

  /**
   * An array of employee IDs that are permitted to use the vehicle
   **/
  @ApiModelProperty(value = "An array of employee IDs that are permitted to use the vehicle")
  public List<Integer> getPermittedEmployees() {
    return permittedEmployees;
  }
  public void setPermittedEmployees(List<Integer> permittedEmployees) {
    this.permittedEmployees = permittedEmployees;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    FleetVehicle fleetVehicle = (FleetVehicle) o;
    return (this.id == null ? fleetVehicle.id == null : this.id.equals(fleetVehicle.id)) &&
        (this.organisationId == null ? fleetVehicle.organisationId == null : this.organisationId.equals(fleetVehicle.organisationId)) &&
        (this.name == null ? fleetVehicle.name == null : this.name.equals(fleetVehicle.name)) &&
        (this.costPerKilometer == null ? fleetVehicle.costPerKilometer == null : this.costPerKilometer.equals(fleetVehicle.costPerKilometer)) &&
        (this.make == null ? fleetVehicle.make == null : this.make.equals(fleetVehicle.make)) &&
        (this.model == null ? fleetVehicle.model == null : this.model.equals(fleetVehicle.model)) &&
        (this.year == null ? fleetVehicle.year == null : this.year.equals(fleetVehicle.year)) &&
        (this.licencePlateNumber == null ? fleetVehicle.licencePlateNumber == null : this.licencePlateNumber.equals(fleetVehicle.licencePlateNumber)) &&
        (this.isDeleted == null ? fleetVehicle.isDeleted == null : this.isDeleted.equals(fleetVehicle.isDeleted)) &&
        (this.permittedEmployees == null ? fleetVehicle.permittedEmployees == null : this.permittedEmployees.equals(fleetVehicle.permittedEmployees));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.id == null ? 0: this.id.hashCode());
    result = 31 * result + (this.organisationId == null ? 0: this.organisationId.hashCode());
    result = 31 * result + (this.name == null ? 0: this.name.hashCode());
    result = 31 * result + (this.costPerKilometer == null ? 0: this.costPerKilometer.hashCode());
    result = 31 * result + (this.make == null ? 0: this.make.hashCode());
    result = 31 * result + (this.model == null ? 0: this.model.hashCode());
    result = 31 * result + (this.year == null ? 0: this.year.hashCode());
    result = 31 * result + (this.licencePlateNumber == null ? 0: this.licencePlateNumber.hashCode());
    result = 31 * result + (this.isDeleted == null ? 0: this.isDeleted.hashCode());
    result = 31 * result + (this.permittedEmployees == null ? 0: this.permittedEmployees.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class FleetVehicle {\n");
    
    sb.append("  id: ").append(id).append("\n");
    sb.append("  organisationId: ").append(organisationId).append("\n");
    sb.append("  name: ").append(name).append("\n");
    sb.append("  costPerKilometer: ").append(costPerKilometer).append("\n");
    sb.append("  make: ").append(make).append("\n");
    sb.append("  model: ").append(model).append("\n");
    sb.append("  year: ").append(year).append("\n");
    sb.append("  licencePlateNumber: ").append(licencePlateNumber).append("\n");
    sb.append("  isDeleted: ").append(isDeleted).append("\n");
    sb.append("  permittedEmployees: ").append(permittedEmployees).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
