/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import java.util.*;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * Fields for inserting a new Job Code
 **/
@ApiModel(description = "Fields for inserting a new Job Code")
public class InsertJobCodeRequest {
  
  @SerializedName("Code")
  private String code = null;
  @SerializedName("ProjectId")
  private Integer projectId = null;
  @SerializedName("ClientId")
  private Integer clientId = null;
  @SerializedName("LinkedTaskIds")
  private List<Integer> linkedTaskIds = null;
  @SerializedName("LinkedOrgGroupIds")
  private List<Integer> linkedOrgGroupIds = null;

  /**
   * A short code for the Job.  This is referred to as a Job Code
   **/
  @ApiModelProperty(value = "A short code for the Job.  This is referred to as a Job Code")
  public String getCode() {
    return code;
  }
  public void setCode(String code) {
    this.code = code;
  }

  /**
   * The linked Project.  Time spent with this JobCode is on this Project
   **/
  @ApiModelProperty(value = "The linked Project.  Time spent with this JobCode is on this Project")
  public Integer getProjectId() {
    return projectId;
  }
  public void setProjectId(Integer projectId) {
    this.projectId = projectId;
  }

  /**
   * The linked Client.  Time spent with this JobCode is for this Client
   **/
  @ApiModelProperty(value = "The linked Client.  Time spent with this JobCode is for this Client")
  public Integer getClientId() {
    return clientId;
  }
  public void setClientId(Integer clientId) {
    this.clientId = clientId;
  }

  /**
   * A list of Task Ids.  This are the Tasks that become available to the employee when they select this JobCode
   **/
  @ApiModelProperty(value = "A list of Task Ids.  This are the Tasks that become available to the employee when they select this JobCode")
  public List<Integer> getLinkedTaskIds() {
    return linkedTaskIds;
  }
  public void setLinkedTaskIds(List<Integer> linkedTaskIds) {
    this.linkedTaskIds = linkedTaskIds;
  }

  /**
   * Optionally restrict access to the JobCode by specifying which Organisation Groups can use it
   **/
  @ApiModelProperty(value = "Optionally restrict access to the JobCode by specifying which Organisation Groups can use it")
  public List<Integer> getLinkedOrgGroupIds() {
    return linkedOrgGroupIds;
  }
  public void setLinkedOrgGroupIds(List<Integer> linkedOrgGroupIds) {
    this.linkedOrgGroupIds = linkedOrgGroupIds;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InsertJobCodeRequest insertJobCodeRequest = (InsertJobCodeRequest) o;
    return (this.code == null ? insertJobCodeRequest.code == null : this.code.equals(insertJobCodeRequest.code)) &&
        (this.projectId == null ? insertJobCodeRequest.projectId == null : this.projectId.equals(insertJobCodeRequest.projectId)) &&
        (this.clientId == null ? insertJobCodeRequest.clientId == null : this.clientId.equals(insertJobCodeRequest.clientId)) &&
        (this.linkedTaskIds == null ? insertJobCodeRequest.linkedTaskIds == null : this.linkedTaskIds.equals(insertJobCodeRequest.linkedTaskIds)) &&
        (this.linkedOrgGroupIds == null ? insertJobCodeRequest.linkedOrgGroupIds == null : this.linkedOrgGroupIds.equals(insertJobCodeRequest.linkedOrgGroupIds));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.code == null ? 0: this.code.hashCode());
    result = 31 * result + (this.projectId == null ? 0: this.projectId.hashCode());
    result = 31 * result + (this.clientId == null ? 0: this.clientId.hashCode());
    result = 31 * result + (this.linkedTaskIds == null ? 0: this.linkedTaskIds.hashCode());
    result = 31 * result + (this.linkedOrgGroupIds == null ? 0: this.linkedOrgGroupIds.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class InsertJobCodeRequest {\n");
    
    sb.append("  code: ").append(code).append("\n");
    sb.append("  projectId: ").append(projectId).append("\n");
    sb.append("  clientId: ").append(clientId).append("\n");
    sb.append("  linkedTaskIds: ").append(linkedTaskIds).append("\n");
    sb.append("  linkedOrgGroupIds: ").append(linkedOrgGroupIds).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
