/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import java.util.Date;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * Fields for inserting a new Project
 **/
@ApiModel(description = "Fields for inserting a new Project")
public class InsertProjectRequest {
  
  @SerializedName("ClientId")
  private Integer clientId = null;
  @SerializedName("ProjectName")
  private String projectName = null;
  @SerializedName("CostEstimation")
  private Double costEstimation = null;
  @SerializedName("StartDate")
  private Date startDate = null;
  @SerializedName("EndDate")
  private Date endDate = null;

  /**
   * The Id of the Client that is associated with the new project
   **/
  @ApiModelProperty(value = "The Id of the Client that is associated with the new project")
  public Integer getClientId() {
    return clientId;
  }
  public void setClientId(Integer clientId) {
    this.clientId = clientId;
  }

  /**
   * The name of the new Project
   **/
  @ApiModelProperty(value = "The name of the new Project")
  public String getProjectName() {
    return projectName;
  }
  public void setProjectName(String projectName) {
    this.projectName = projectName;
  }

  /**
   * The estimated cost of work to complete the project.  This value is used in the Organisation Reports view 'Project Costs'
   **/
  @ApiModelProperty(value = "The estimated cost of work to complete the project.  This value is used in the Organisation Reports view 'Project Costs'")
  public Double getCostEstimation() {
    return costEstimation;
  }
  public void setCostEstimation(Double costEstimation) {
    this.costEstimation = costEstimation;
  }

  /**
   * The start date of the project.  When the project is due to start
   **/
  @ApiModelProperty(value = "The start date of the project.  When the project is due to start")
  public Date getStartDate() {
    return startDate;
  }
  public void setStartDate(Date startDate) {
    this.startDate = startDate;
  }

  /**
   * The end date of the project.  When the project is due to end
   **/
  @ApiModelProperty(value = "The end date of the project.  When the project is due to end")
  public Date getEndDate() {
    return endDate;
  }
  public void setEndDate(Date endDate) {
    this.endDate = endDate;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InsertProjectRequest insertProjectRequest = (InsertProjectRequest) o;
    return (this.clientId == null ? insertProjectRequest.clientId == null : this.clientId.equals(insertProjectRequest.clientId)) &&
        (this.projectName == null ? insertProjectRequest.projectName == null : this.projectName.equals(insertProjectRequest.projectName)) &&
        (this.costEstimation == null ? insertProjectRequest.costEstimation == null : this.costEstimation.equals(insertProjectRequest.costEstimation)) &&
        (this.startDate == null ? insertProjectRequest.startDate == null : this.startDate.equals(insertProjectRequest.startDate)) &&
        (this.endDate == null ? insertProjectRequest.endDate == null : this.endDate.equals(insertProjectRequest.endDate));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.clientId == null ? 0: this.clientId.hashCode());
    result = 31 * result + (this.projectName == null ? 0: this.projectName.hashCode());
    result = 31 * result + (this.costEstimation == null ? 0: this.costEstimation.hashCode());
    result = 31 * result + (this.startDate == null ? 0: this.startDate.hashCode());
    result = 31 * result + (this.endDate == null ? 0: this.endDate.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class InsertProjectRequest {\n");
    
    sb.append("  clientId: ").append(clientId).append("\n");
    sb.append("  projectName: ").append(projectName).append("\n");
    sb.append("  costEstimation: ").append(costEstimation).append("\n");
    sb.append("  startDate: ").append(startDate).append("\n");
    sb.append("  endDate: ").append(endDate).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
