/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import java.util.Date;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * Fields for Inserting a new User account (employee) under your Organisation in ChronoSheets
 **/
@ApiModel(description = "Fields for Inserting a new User account (employee) under your Organisation in ChronoSheets")
public class InsertUserRequest {
  
  @SerializedName("EmailAddress")
  private String emailAddress = null;
  @SerializedName("FirstName")
  private String firstName = null;
  @SerializedName("LastName")
  private String lastName = null;
  @SerializedName("IsSubscribedToNewsletter")
  private Boolean isSubscribedToNewsletter = null;
  @SerializedName("Roles")
  private Long roles = null;
  @SerializedName("AlertSettings")
  private Long alertSettings = null;
  @SerializedName("UserName")
  private String userName = null;
  @SerializedName("HourlyPayRate")
  private Double hourlyPayRate = null;
  @SerializedName("HourlyOvertimePayRate")
  private Double hourlyOvertimePayRate = null;
  @SerializedName("CurrentDate")
  private Date currentDate = null;

  /**
   * The Email Address of the employee
   **/
  @ApiModelProperty(value = "The Email Address of the employee")
  public String getEmailAddress() {
    return emailAddress;
  }
  public void setEmailAddress(String emailAddress) {
    this.emailAddress = emailAddress;
  }

  /**
   * The First Name of the employee
   **/
  @ApiModelProperty(value = "The First Name of the employee")
  public String getFirstName() {
    return firstName;
  }
  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  /**
   * The Last Name of the employee
   **/
  @ApiModelProperty(value = "The Last Name of the employee")
  public String getLastName() {
    return lastName;
  }
  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  /**
   * Whether or not the employee is subscribed to ChronoSheets newsletters
   **/
  @ApiModelProperty(value = "Whether or not the employee is subscribed to ChronoSheets newsletters")
  public Boolean getIsSubscribedToNewsletter() {
    return isSubscribedToNewsletter;
  }
  public void setIsSubscribedToNewsletter(Boolean isSubscribedToNewsletter) {
    this.isSubscribedToNewsletter = isSubscribedToNewsletter;
  }

  /**
   * A BIT field designating which Roles/Permissions the employee will have when they sign in.  See the timesheets.types.Enums.UserRoles Enum for more details
   **/
  @ApiModelProperty(value = "A BIT field designating which Roles/Permissions the employee will have when they sign in.  See the timesheets.types.Enums.UserRoles Enum for more details")
  public Long getRoles() {
    return roles;
  }
  public void setRoles(Long roles) {
    this.roles = roles;
  }

  /**
   * A BIT field designating which Alerts the employee will receive.  See the timesheets.types.Enums.AlertSettings Enum for more details
   **/
  @ApiModelProperty(value = "A BIT field designating which Alerts the employee will receive.  See the timesheets.types.Enums.AlertSettings Enum for more details")
  public Long getAlertSettings() {
    return alertSettings;
  }
  public void setAlertSettings(Long alertSettings) {
    this.alertSettings = alertSettings;
  }

  /**
   * The UserName of the employee.  This can be used when logging into ChronoSheets
   **/
  @ApiModelProperty(value = "The UserName of the employee.  This can be used when logging into ChronoSheets")
  public String getUserName() {
    return userName;
  }
  public void setUserName(String userName) {
    this.userName = userName;
  }

  /**
   * Set the starting usual Hourly Pay Rate with this value.  This is the Pay Rate the employee receives for working during Rostered Hours
   **/
  @ApiModelProperty(value = "Set the starting usual Hourly Pay Rate with this value.  This is the Pay Rate the employee receives for working during Rostered Hours")
  public Double getHourlyPayRate() {
    return hourlyPayRate;
  }
  public void setHourlyPayRate(Double hourlyPayRate) {
    this.hourlyPayRate = hourlyPayRate;
  }

  /**
   * Set the starting usual Overtime Hourly Pay Rate with this value.  This is the Pay Rate the employee receives for working outside of Rostered Hours
   **/
  @ApiModelProperty(value = "Set the starting usual Overtime Hourly Pay Rate with this value.  This is the Pay Rate the employee receives for working outside of Rostered Hours")
  public Double getHourlyOvertimePayRate() {
    return hourlyOvertimePayRate;
  }
  public void setHourlyOvertimePayRate(Double hourlyOvertimePayRate) {
    this.hourlyOvertimePayRate = hourlyOvertimePayRate;
  }

  /**
   * The Current date time
   **/
  @ApiModelProperty(value = "The Current date time")
  public Date getCurrentDate() {
    return currentDate;
  }
  public void setCurrentDate(Date currentDate) {
    this.currentDate = currentDate;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    InsertUserRequest insertUserRequest = (InsertUserRequest) o;
    return (this.emailAddress == null ? insertUserRequest.emailAddress == null : this.emailAddress.equals(insertUserRequest.emailAddress)) &&
        (this.firstName == null ? insertUserRequest.firstName == null : this.firstName.equals(insertUserRequest.firstName)) &&
        (this.lastName == null ? insertUserRequest.lastName == null : this.lastName.equals(insertUserRequest.lastName)) &&
        (this.isSubscribedToNewsletter == null ? insertUserRequest.isSubscribedToNewsletter == null : this.isSubscribedToNewsletter.equals(insertUserRequest.isSubscribedToNewsletter)) &&
        (this.roles == null ? insertUserRequest.roles == null : this.roles.equals(insertUserRequest.roles)) &&
        (this.alertSettings == null ? insertUserRequest.alertSettings == null : this.alertSettings.equals(insertUserRequest.alertSettings)) &&
        (this.userName == null ? insertUserRequest.userName == null : this.userName.equals(insertUserRequest.userName)) &&
        (this.hourlyPayRate == null ? insertUserRequest.hourlyPayRate == null : this.hourlyPayRate.equals(insertUserRequest.hourlyPayRate)) &&
        (this.hourlyOvertimePayRate == null ? insertUserRequest.hourlyOvertimePayRate == null : this.hourlyOvertimePayRate.equals(insertUserRequest.hourlyOvertimePayRate)) &&
        (this.currentDate == null ? insertUserRequest.currentDate == null : this.currentDate.equals(insertUserRequest.currentDate));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.emailAddress == null ? 0: this.emailAddress.hashCode());
    result = 31 * result + (this.firstName == null ? 0: this.firstName.hashCode());
    result = 31 * result + (this.lastName == null ? 0: this.lastName.hashCode());
    result = 31 * result + (this.isSubscribedToNewsletter == null ? 0: this.isSubscribedToNewsletter.hashCode());
    result = 31 * result + (this.roles == null ? 0: this.roles.hashCode());
    result = 31 * result + (this.alertSettings == null ? 0: this.alertSettings.hashCode());
    result = 31 * result + (this.userName == null ? 0: this.userName.hashCode());
    result = 31 * result + (this.hourlyPayRate == null ? 0: this.hourlyPayRate.hashCode());
    result = 31 * result + (this.hourlyOvertimePayRate == null ? 0: this.hourlyOvertimePayRate.hashCode());
    result = 31 * result + (this.currentDate == null ? 0: this.currentDate.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class InsertUserRequest {\n");
    
    sb.append("  emailAddress: ").append(emailAddress).append("\n");
    sb.append("  firstName: ").append(firstName).append("\n");
    sb.append("  lastName: ").append(lastName).append("\n");
    sb.append("  isSubscribedToNewsletter: ").append(isSubscribedToNewsletter).append("\n");
    sb.append("  roles: ").append(roles).append("\n");
    sb.append("  alertSettings: ").append(alertSettings).append("\n");
    sb.append("  userName: ").append(userName).append("\n");
    sb.append("  hourlyPayRate: ").append(hourlyPayRate).append("\n");
    sb.append("  hourlyOvertimePayRate: ").append(hourlyOvertimePayRate).append("\n");
    sb.append("  currentDate: ").append(currentDate).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
