/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import java.util.*;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

/**
 * Fields for saving an existing Vehicle
 **/
@ApiModel(description = "Fields for saving an existing Vehicle")
public class SaveVehicleRequest {
  
  @SerializedName("Id")
  private Integer id = null;
  @SerializedName("Name")
  private String name = null;
  @SerializedName("CostPerKilometer")
  private Double costPerKilometer = null;
  @SerializedName("Make")
  private String make = null;
  @SerializedName("Model")
  private String model = null;
  @SerializedName("Year")
  private String year = null;
  @SerializedName("LicencePlateNumber")
  private String licencePlateNumber = null;
  @SerializedName("LinkedOrgGroupIds")
  private List<Integer> linkedOrgGroupIds = null;
  @SerializedName("IsDeleted")
  private Boolean isDeleted = null;

  /**
   * The Id of the Vehicle that is being updated
   **/
  @ApiModelProperty(value = "The Id of the Vehicle that is being updated")
  public Integer getId() {
    return id;
  }
  public void setId(Integer id) {
    this.id = id;
  }

  /**
   * The Name of the Vehicle
   **/
  @ApiModelProperty(value = "The Name of the Vehicle")
  public String getName() {
    return name;
  }
  public void setName(String name) {
    this.name = name;
  }

  /**
   * The fuel cost / running cost of the Vehicle, measured per kilometer
   **/
  @ApiModelProperty(value = "The fuel cost / running cost of the Vehicle, measured per kilometer")
  public Double getCostPerKilometer() {
    return costPerKilometer;
  }
  public void setCostPerKilometer(Double costPerKilometer) {
    this.costPerKilometer = costPerKilometer;
  }

  /**
   * The make of the Vehicle
   **/
  @ApiModelProperty(value = "The make of the Vehicle")
  public String getMake() {
    return make;
  }
  public void setMake(String make) {
    this.make = make;
  }

  /**
   * The model of the Vehicle
   **/
  @ApiModelProperty(value = "The model of the Vehicle")
  public String getModel() {
    return model;
  }
  public void setModel(String model) {
    this.model = model;
  }

  /**
   * The year the Vehicle was made
   **/
  @ApiModelProperty(value = "The year the Vehicle was made")
  public String getYear() {
    return year;
  }
  public void setYear(String year) {
    this.year = year;
  }

  /**
   * The Licence Plate Number of the Vehicle
   **/
  @ApiModelProperty(value = "The Licence Plate Number of the Vehicle")
  public String getLicencePlateNumber() {
    return licencePlateNumber;
  }
  public void setLicencePlateNumber(String licencePlateNumber) {
    this.licencePlateNumber = licencePlateNumber;
  }

  /**
   * Optionally restrict this Vehicle to only be available to employees within these Organisation Groups
   **/
  @ApiModelProperty(value = "Optionally restrict this Vehicle to only be available to employees within these Organisation Groups")
  public List<Integer> getLinkedOrgGroupIds() {
    return linkedOrgGroupIds;
  }
  public void setLinkedOrgGroupIds(List<Integer> linkedOrgGroupIds) {
    this.linkedOrgGroupIds = linkedOrgGroupIds;
  }

  /**
   * Whether or not this Vehicle is to be marked as deleted
   **/
  @ApiModelProperty(value = "Whether or not this Vehicle is to be marked as deleted")
  public Boolean getIsDeleted() {
    return isDeleted;
  }
  public void setIsDeleted(Boolean isDeleted) {
    this.isDeleted = isDeleted;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    SaveVehicleRequest saveVehicleRequest = (SaveVehicleRequest) o;
    return (this.id == null ? saveVehicleRequest.id == null : this.id.equals(saveVehicleRequest.id)) &&
        (this.name == null ? saveVehicleRequest.name == null : this.name.equals(saveVehicleRequest.name)) &&
        (this.costPerKilometer == null ? saveVehicleRequest.costPerKilometer == null : this.costPerKilometer.equals(saveVehicleRequest.costPerKilometer)) &&
        (this.make == null ? saveVehicleRequest.make == null : this.make.equals(saveVehicleRequest.make)) &&
        (this.model == null ? saveVehicleRequest.model == null : this.model.equals(saveVehicleRequest.model)) &&
        (this.year == null ? saveVehicleRequest.year == null : this.year.equals(saveVehicleRequest.year)) &&
        (this.licencePlateNumber == null ? saveVehicleRequest.licencePlateNumber == null : this.licencePlateNumber.equals(saveVehicleRequest.licencePlateNumber)) &&
        (this.linkedOrgGroupIds == null ? saveVehicleRequest.linkedOrgGroupIds == null : this.linkedOrgGroupIds.equals(saveVehicleRequest.linkedOrgGroupIds)) &&
        (this.isDeleted == null ? saveVehicleRequest.isDeleted == null : this.isDeleted.equals(saveVehicleRequest.isDeleted));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.id == null ? 0: this.id.hashCode());
    result = 31 * result + (this.name == null ? 0: this.name.hashCode());
    result = 31 * result + (this.costPerKilometer == null ? 0: this.costPerKilometer.hashCode());
    result = 31 * result + (this.make == null ? 0: this.make.hashCode());
    result = 31 * result + (this.model == null ? 0: this.model.hashCode());
    result = 31 * result + (this.year == null ? 0: this.year.hashCode());
    result = 31 * result + (this.licencePlateNumber == null ? 0: this.licencePlateNumber.hashCode());
    result = 31 * result + (this.linkedOrgGroupIds == null ? 0: this.linkedOrgGroupIds.hashCode());
    result = 31 * result + (this.isDeleted == null ? 0: this.isDeleted.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class SaveVehicleRequest {\n");
    
    sb.append("  id: ").append(id).append("\n");
    sb.append("  name: ").append(name).append("\n");
    sb.append("  costPerKilometer: ").append(costPerKilometer).append("\n");
    sb.append("  make: ").append(make).append("\n");
    sb.append("  model: ").append(model).append("\n");
    sb.append("  year: ").append(year).append("\n");
    sb.append("  licencePlateNumber: ").append(licencePlateNumber).append("\n");
    sb.append("  linkedOrgGroupIds: ").append(linkedOrgGroupIds).append("\n");
    sb.append("  isDeleted: ").append(isDeleted).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
