/**
 * ChronoSheets API
 * <div style='font-size: 14px!important;font-family: Open Sans,sans-serif!important;color: #3b4151!important;'><p>     ChronoSheets is a flexible timesheet solution for small to medium businesses, it is free for small teams of up to 3 and there are iOS and Android apps available.  Use the ChronoSheets API to create your own custom integrations.  Before starting, sign up for a ChronoSheets account at <a target='_BLANK' href='http://tsheets.xyz/signup'>http://tsheets.xyz/signup</a>. </p></div><div id='cs-extra-info'></div>
 *
 * The version of the OpenAPI document: v1
 * Contact: lachlan@chronosheets.com
 *
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

package ChronoSheetsClientLibModel;

import ChronoSheetsClientLibModel.Organisation;
import io.swagger.annotations.*;
import com.google.gson.annotations.SerializedName;

@ApiModel(description = "")
public class UserForManagement {
  
  @SerializedName("Id")
  private Integer id = null;
  @SerializedName("OrganisationId")
  private Integer organisationId = null;
  @SerializedName("UserName")
  private String userName = null;
  @SerializedName("FirstName")
  private String firstName = null;
  @SerializedName("LastName")
  private String lastName = null;
  @SerializedName("EmailAddress")
  private String emailAddress = null;
  @SerializedName("Roles")
  private Long roles = null;
  @SerializedName("AlertSettings")
  private Long alertSettings = null;
  @SerializedName("SetupWizardRequired")
  private Boolean setupWizardRequired = null;
  @SerializedName("IsSubscribedToNewsletter")
  private Boolean isSubscribedToNewsletter = null;
  @SerializedName("Organisation")
  private Organisation organisation = null;
  @SerializedName("IsPrimaryAccount")
  private Boolean isPrimaryAccount = null;
  @SerializedName("IsAccountActive")
  private Boolean isAccountActive = null;

  /**
   * The ID of the user
   **/
  @ApiModelProperty(value = "The ID of the user")
  public Integer getId() {
    return id;
  }
  public void setId(Integer id) {
    this.id = id;
  }

  /**
   * The ID of the organisation
   **/
  @ApiModelProperty(value = "The ID of the organisation")
  public Integer getOrganisationId() {
    return organisationId;
  }
  public void setOrganisationId(Integer organisationId) {
    this.organisationId = organisationId;
  }

  /**
   * The username of the user
   **/
  @ApiModelProperty(value = "The username of the user")
  public String getUserName() {
    return userName;
  }
  public void setUserName(String userName) {
    this.userName = userName;
  }

  /**
   * The first name of the user
   **/
  @ApiModelProperty(value = "The first name of the user")
  public String getFirstName() {
    return firstName;
  }
  public void setFirstName(String firstName) {
    this.firstName = firstName;
  }

  /**
   * The last name of the user
   **/
  @ApiModelProperty(value = "The last name of the user")
  public String getLastName() {
    return lastName;
  }
  public void setLastName(String lastName) {
    this.lastName = lastName;
  }

  /**
   * The email address of the user
   **/
  @ApiModelProperty(value = "The email address of the user")
  public String getEmailAddress() {
    return emailAddress;
  }
  public void setEmailAddress(String emailAddress) {
    this.emailAddress = emailAddress;
  }

  /**
   * A BIT field designating which Roles/Permissions the employee will have when they sign in.  See the timesheets.types.Enums.UserRoles Enum for more details
   **/
  @ApiModelProperty(value = "A BIT field designating which Roles/Permissions the employee will have when they sign in.  See the timesheets.types.Enums.UserRoles Enum for more details")
  public Long getRoles() {
    return roles;
  }
  public void setRoles(Long roles) {
    this.roles = roles;
  }

  /**
   * A BIT field designating which Alerts the employee will receive.  See the timesheets.types.Enums.AlertSettings Enum for more details
   **/
  @ApiModelProperty(value = "A BIT field designating which Alerts the employee will receive.  See the timesheets.types.Enums.AlertSettings Enum for more details")
  public Long getAlertSettings() {
    return alertSettings;
  }
  public void setAlertSettings(Long alertSettings) {
    this.alertSettings = alertSettings;
  }

  /**
   * Whether or not the setup wizard is required
   **/
  @ApiModelProperty(value = "Whether or not the setup wizard is required")
  public Boolean getSetupWizardRequired() {
    return setupWizardRequired;
  }
  public void setSetupWizardRequired(Boolean setupWizardRequired) {
    this.setupWizardRequired = setupWizardRequired;
  }

  /**
   * Whether or not the user is subscribed to the user
   **/
  @ApiModelProperty(value = "Whether or not the user is subscribed to the user")
  public Boolean getIsSubscribedToNewsletter() {
    return isSubscribedToNewsletter;
  }
  public void setIsSubscribedToNewsletter(Boolean isSubscribedToNewsletter) {
    this.isSubscribedToNewsletter = isSubscribedToNewsletter;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public Organisation getOrganisation() {
    return organisation;
  }
  public void setOrganisation(Organisation organisation) {
    this.organisation = organisation;
  }

  /**
   * Whether or not this account is the organisation's primary account.
   **/
  @ApiModelProperty(value = "Whether or not this account is the organisation's primary account.")
  public Boolean getIsPrimaryAccount() {
    return isPrimaryAccount;
  }
  public void setIsPrimaryAccount(Boolean isPrimaryAccount) {
    this.isPrimaryAccount = isPrimaryAccount;
  }

  /**
   **/
  @ApiModelProperty(value = "")
  public Boolean getIsAccountActive() {
    return isAccountActive;
  }
  public void setIsAccountActive(Boolean isAccountActive) {
    this.isAccountActive = isAccountActive;
  }


  @Override
  public boolean equals(Object o) {
    if (this == o) {
      return true;
    }
    if (o == null || getClass() != o.getClass()) {
      return false;
    }
    UserForManagement userForManagement = (UserForManagement) o;
    return (this.id == null ? userForManagement.id == null : this.id.equals(userForManagement.id)) &&
        (this.organisationId == null ? userForManagement.organisationId == null : this.organisationId.equals(userForManagement.organisationId)) &&
        (this.userName == null ? userForManagement.userName == null : this.userName.equals(userForManagement.userName)) &&
        (this.firstName == null ? userForManagement.firstName == null : this.firstName.equals(userForManagement.firstName)) &&
        (this.lastName == null ? userForManagement.lastName == null : this.lastName.equals(userForManagement.lastName)) &&
        (this.emailAddress == null ? userForManagement.emailAddress == null : this.emailAddress.equals(userForManagement.emailAddress)) &&
        (this.roles == null ? userForManagement.roles == null : this.roles.equals(userForManagement.roles)) &&
        (this.alertSettings == null ? userForManagement.alertSettings == null : this.alertSettings.equals(userForManagement.alertSettings)) &&
        (this.setupWizardRequired == null ? userForManagement.setupWizardRequired == null : this.setupWizardRequired.equals(userForManagement.setupWizardRequired)) &&
        (this.isSubscribedToNewsletter == null ? userForManagement.isSubscribedToNewsletter == null : this.isSubscribedToNewsletter.equals(userForManagement.isSubscribedToNewsletter)) &&
        (this.organisation == null ? userForManagement.organisation == null : this.organisation.equals(userForManagement.organisation)) &&
        (this.isPrimaryAccount == null ? userForManagement.isPrimaryAccount == null : this.isPrimaryAccount.equals(userForManagement.isPrimaryAccount)) &&
        (this.isAccountActive == null ? userForManagement.isAccountActive == null : this.isAccountActive.equals(userForManagement.isAccountActive));
  }

  @Override
  public int hashCode() {
    int result = 17;
    result = 31 * result + (this.id == null ? 0: this.id.hashCode());
    result = 31 * result + (this.organisationId == null ? 0: this.organisationId.hashCode());
    result = 31 * result + (this.userName == null ? 0: this.userName.hashCode());
    result = 31 * result + (this.firstName == null ? 0: this.firstName.hashCode());
    result = 31 * result + (this.lastName == null ? 0: this.lastName.hashCode());
    result = 31 * result + (this.emailAddress == null ? 0: this.emailAddress.hashCode());
    result = 31 * result + (this.roles == null ? 0: this.roles.hashCode());
    result = 31 * result + (this.alertSettings == null ? 0: this.alertSettings.hashCode());
    result = 31 * result + (this.setupWizardRequired == null ? 0: this.setupWizardRequired.hashCode());
    result = 31 * result + (this.isSubscribedToNewsletter == null ? 0: this.isSubscribedToNewsletter.hashCode());
    result = 31 * result + (this.organisation == null ? 0: this.organisation.hashCode());
    result = 31 * result + (this.isPrimaryAccount == null ? 0: this.isPrimaryAccount.hashCode());
    result = 31 * result + (this.isAccountActive == null ? 0: this.isAccountActive.hashCode());
    return result;
  }

  @Override
  public String toString()  {
    StringBuilder sb = new StringBuilder();
    sb.append("class UserForManagement {\n");
    
    sb.append("  id: ").append(id).append("\n");
    sb.append("  organisationId: ").append(organisationId).append("\n");
    sb.append("  userName: ").append(userName).append("\n");
    sb.append("  firstName: ").append(firstName).append("\n");
    sb.append("  lastName: ").append(lastName).append("\n");
    sb.append("  emailAddress: ").append(emailAddress).append("\n");
    sb.append("  roles: ").append(roles).append("\n");
    sb.append("  alertSettings: ").append(alertSettings).append("\n");
    sb.append("  setupWizardRequired: ").append(setupWizardRequired).append("\n");
    sb.append("  isSubscribedToNewsletter: ").append(isSubscribedToNewsletter).append("\n");
    sb.append("  organisation: ").append(organisation).append("\n");
    sb.append("  isPrimaryAccount: ").append(isPrimaryAccount).append("\n");
    sb.append("  isAccountActive: ").append(isAccountActive).append("\n");
    sb.append("}\n");
    return sb.toString();
  }
}
